#ifndef TAP_API_ERROR_H
#define TAP_API_ERROR_H

//=============================================================================
/**
 *	\addtogroup G_ERR_INNER_API		TapAPIڲصĴ붨塣
 *	@{
 */
//=============================================================================
//! ɹ
const int TAPIERROR_SUCCEED                                            = 0;
//! ӷʧ
const int TAPIERROR_ConnectFail                                        = -1;
//! ·֤ʧ
const int TAPIERROR_LinkAuthFail                                       = -2;
//! ַ
const int TAPIERROR_HostUnavailable                                    = -3;
//! ݴ
const int TAPIERROR_SendDataError                                      = -4;
//! ԱŲϷ
const int TAPIERROR_TestIDError                                        = -5;
//! û׼ò
const int TAPIERROR_NotReadyTestNetwork                                = -6;
//! ǰԻû
const int TAPIERROR_CurTestNotOver                                     = -7;
//! ûÿõĽǰ
const int TAPIERROR_NOFrontAvailable                                   = -8;
//! ·
const int TAPIERROR_DataPathAvaiable                                   = -9;
//! ظ¼
const int TAPIERROR_RepeatLogin                                        = -10;
//! ڲ	
const int TAPIERROR_InnerError                                         = -11;
//! һûн	
const int TAPIERROR_LastReqNotFinish                                   = -12;
//! Ƿ	
const int TAPIERROR_InputValueError                                    = -13;
//! Ȩ벻Ϸ	
const int TAPIERROR_AuthCode_Invalid                                   = -14;
//! Ȩ볬	
const int TAPIERROR_AuthCode_Expired                                   = -15;
//! ȨͲƥ	
const int TAPIERROR_AuthCode_TypeNotMatch                              = -16;
//! APIû׼
const int TAPIERROR_API_NotReady                                       = -17;
//! UDP˿ڼʧ
const int TAPIERROR_UDP_LISTEN_FAILED                                  = -18;
//! UDPڼ
const int TAPIERROR_UDP_LISTENING                                      = -19;
//! ӿδʵ
const int TAPIERROR_NotImplemented                                     = -20;
//! ÿε½ֻһ
const int TAPIERROR_CallOneTimeOnly                                    = -21;

/** @}*/


//=============================================================================
/**
 *	\addtogroup G_ERR_INPUT_CHECK		
 *	@{
 */
//=============================================================================
//! ΪNULL
const int TAPIERROR_INPUTERROR_NULL                                    = -10000;
//! :TAPIYNFLAG
const int TAPIERROR_INPUTERROR_TAPIYNFLAG                              = -10001;
//! :TAPILOGLEVEL
const int TAPIERROR_INPUTERROR_TAPILOGLEVEL                            = -10002;
//! :TAPICommodityType
const int TAPIERROR_INPUTERROR_TAPICommodityType                       = -10003;
//! :TAPICallOrPutFlagType
const int TAPIERROR_INPUTERROR_TAPICallOrPutFlagType                   = -10004;
//! :TAPIBucketDateFlag
const int TAPIERROR_INPUTERROR_TAPIBucketDateFlag                      = -11001;
//! :TAPIHisQuoteType
const int TAPIERROR_INPUTERROR_TAPIHisQuoteType                        = -11002;
//! :TAPIAccountType
const int TAPIERROR_INPUTERROR_TAPIAccountType                         = -12001;
//! :TAPIUserTypeType
const int TAPIERROR_INPUTERROR_TAPIUserTypeType                        = -12002;
//! :TAPIAccountState
const int TAPIERROR_INPUTERROR_TAPIAccountState                        = -12003;
//! :TAPIAccountFamilyType
const int TAPIERROR_INPUTERROR_TAPIAccountFamilyType                   = -12004;
//! :TAPIOrderTypeType
const int TAPIERROR_INPUTERROR_TAPIOrderTypeType                       = -12005;
//! :TAPIOrderSourceType
const int TAPIERROR_INPUTERROR_TAPIOrderSourceType                     = -12006;
//! :TAPITimeInForceType
const int TAPIERROR_INPUTERROR_TAPITimeInForceType                     = -12007;
//! :TAPISideType
const int TAPIERROR_INPUTERROR_TAPISideType                            = -12008;
//! :TAPIPositionEffectType
const int TAPIERROR_INPUTERROR_TAPIPositionEffectType                  = -12009;
//! :TAPIHedgeFlagType
const int TAPIERROR_INPUTERROR_TAPIHedgeFlagType                       = -12010;
//! :TAPIOrderStateType
const int TAPIERROR_INPUTERROR_TAPIOrderStateType                      = -12011;
//! :TAPICalculateModeType
const int TAPIERROR_INPUTERROR_TAPICalculateModeType                   = -12012;
//! :TAPIMatchSourceType
const int TAPIERROR_INPUTERROR_TAPIMatchSourceType                     = -12013;
//! :TAPIOpenCloseModeType
const int TAPIERROR_INPUTERROR_TAPIOpenCloseModeType                   = -12014;
//! :TAPIFutureAlgType
const int TAPIERROR_INPUTERROR_TAPIFutureAlgType                       = -12015;
//! :TAPIOptionAlgType
const int TAPIERROR_INPUTERROR_TAPIOptionAlgType                       = -12016;
//! :TAPIBankAccountLWFlagType
const int TAPIERROR_INPUTERROR_TAPIBankAccountLWFlagType               = -12017;
//! :TAPIBankAccountStateType
const int TAPIERROR_INPUTERROR_TAPIBankAccountStateType                = -12018;
//! :TAPIBankAccountSwapStateType
const int TAPIERROR_INPUTERROR_TAPIBankAccountSwapStateType            = -12019;
//! :TAPIBankAccountTransferStateType
const int TAPIERROR_INPUTERROR_TAPIBankAccountTransferStateType        = -12020;
//! :TAPIMarginCalculateModeType
const int TAPIERROR_INPUTERROR_TAPIMarginCalculateModeType             = -12021;
//! :TAPIOptionMarginCalculateModeType
const int TAPIERROR_INPUTERROR_TAPIOptionMarginCalculateModeType       = -12022;
//! :TAPICmbDirectType
const int TAPIERROR_INPUTERROR_TAPICmbDirectType                       = -12023;
//! :TAPIDeliveryModeType
const int TAPIERROR_INPUTERROR_TAPIDeliveryModeType                    = -12024;
//! :TAPIContractTypeType
const int TAPIERROR_INPUTERROR_TAPIContractTypeType                    = -12025;
//! :TAPIPartyTypeType
const int TAPIERROR_INPUTERROR_TAPIPartyTypeType                       = -12026;
//! :TAPIPartyCertificateTypeType
const int TAPIERROR_INPUTERROR_TAPIPartyCertificateTypeType            = -12027;
//! :TAPIMsgReceiverType
const int TAPIERROR_INPUTERROR_TAPIMsgReceiverType                     = -12028;
//! :TAPIMsgTypeType
const int TAPIERROR_INPUTERROR_TAPIMsgTypeType                         = -12029;
//! :TAPIMsgLevelType
const int TAPIERROR_INPUTERROR_TAPIMsgLevelType                        = -12030;
//! :TAPITransferDirectType
const int TAPIERROR_INPUTERROR_TAPITransferDirectType                  = -12031;
//! :TAPITransferStateType
const int TAPIERROR_INPUTERROR_TAPITransferStateType                   = -12032;
//! :TAPITransferTypeType
const int TAPIERROR_INPUTERROR_TAPITransferTypeType                    = -12033;
//! :TAPITransferDeviceIDType
const int TAPIERROR_INPUTERROR_TAPITransferDeviceIDType                = -12034;
//! :TAPITacticsTypeType
const int TAPIERROR_INPUTERROR_TAPITacticsTypeType                     = -12035;
//! :TAPIORDERACT
const int TAPIERROR_INPUTERROR_TAPIORDERACT                            = -12036;
//! :TAPIBillTypeType
const int TAPIERROR_INPUTERROR_TAPIBillTypeType                        = -12037;
//! :TAPIBillFileTypeType
const int TAPIERROR_INPUTERROR_TAPIBillFileTypeType                    = -12038;
//! :TAPIOFFFlagType
const int TAPIERROR_INPUTERROR_TAPIOFFFlagType                         = -12039;
//! :TAPICashAdjustTypeType
const int TAPIERROR_INPUTERROR_TAPICashAdjustTypeType                  = -12040;
//! :TAPITriggerConditionType
const int TAPIERROR_INPUTERROR_TAPITriggerConditionType                = -12041;
//! :TAPITriggerPriceTypeType
const int TAPIERROR_INPUTERROR_TAPITriggerPriceTypeType                = -12042;
//! :TAPITradingStateType 
const int TAPIERROR_INPUTERROR_TAPITradingStateType                    = -12043;
//! :TAPIMarketLevelType 
const int TAPIERROR_INPUTERROR_TAPIMarketLevelType                     = -12044;
//! :TAPIOrderQryTypeType 
const int TAPIERROR_INPUTERROR_TAPIOrderQryTypeType                    = -12045;

//! ʷѯϷ
const int TAPIERROR_INPUTERROR_QryHisQuoteParam                        = -13001;

/** @}*/

//=============================================================================
/**
 *	\addtogroup G_ERR_DISCONNECT_REASON	Ͽ붨
 *	@{
 */
//=============================================================================
//! Ͽ
const int TAPIERROR_DISCONNECT_CLOSE_INIT                              = 1;
//! Ͽ
const int TAPIERROR_DISCONNECT_CLOSE_PASS                              = 2;
//! 
const int TAPIERROR_DISCONNECT_READ_ERROR                              = 3;
//! д
const int TAPIERROR_DISCONNECT_WRITE_ERROR                             = 4;
//! 
const int TAPIERROR_DISCONNECT_BUF_FULL                                = 5;
//! 첽
const int TAPIERROR_DISCONNECT_IOCP_ERROR                              = 6;
//! ݴ
const int TAPIERROR_DISCONNECT_PARSE_ERROR                             = 7;
//! ӳʱ
const int TAPIERROR_DISCONNECT_CONNECT_TIMEOUT                         = 8;
//! ʼʧ
const int TAPIERROR_DISCONNECT_INIT_ERROR                              = 9;
//! Ѿ
const int TAPIERROR_DISCONNECT_HAS_CONNECTED                           = 10;
//! ߳ѽ
const int TAPIERROR_DISCONNECT_HAS_EXIT                                = 11;
//! ڽУԺ
const int TAPIERROR_DISCONNECT_TRY_LATER                               = 12;

/** @}*/

//=============================================================================
/**
 *	\addtogroup G_ERR_BUSINESS	ҵ񷵻صĴ붨
 *	@{
 */
//=============================================================================

//! ¼ִд
const int TAPIERROR_LOGIN                                              = 10001;
//! ¼û
const int TAPIERROR_LOGIN_USER                                         = 10002;
//! Ҫж̬֤
const int TAPIERROR_LOGIN_DDA                                          = 10003;
//! ¼ûδȨ
const int TAPIERROR_LOGIN_LICENSE                                      = 10004;
//! ¼ģ鲻ȷ
const int TAPIERROR_LOGIN_MODULE                                       = 10005;
//! Ҫǿ޸
const int TAPIERROR_LOGIN_FORCE                                        = 10006;
//! ¼״ֹ̬½
const int TAPIERROR_LOGIN_STATE                                        = 10007;
//! ¼벻ȷ
const int TAPIERROR_LOGIN_PASS                                         = 10008;
//! ûиģ¼Ȩ
const int TAPIERROR_LOGIN_RIGHT                                        = 10009;
//! ¼
const int TAPIERROR_LOGIN_COUNT                                        = 10010;
//! ¼ûڷʶ¿ɵ¼ûб
const int TAPIERROR_LOGIN_NOTIN_SERVERFLAGUSRES                        = 10011;

//=============================================================================
//! ¼ûϢѯʧ
const int TAPIERROR_USERINFO_QRY                                       = 10101;
//! ¼ûϢʧ
const int TAPIERROR_USERINFO_ADD                                       = 10102;
//! ¼ûϢ޸ʧ
const int TAPIERROR_USERINFO_MOD                                       = 10103;
//! ¼ûϢɾʧ
const int TAPIERROR_USERINFO_DEL                                       = 10104;
//! ڹϢɾʧ
const int TAPIERROR_ACCOUNTNO_IN_USERINFO_DEL                          = 10105;

//=============================================================================
//! ¼û״̬ѯʧ
const int TAPIERROR_USERSTATE_QRY                                      = 10201;
//! ¼û״̬ʧ
const int TAPIERROR_USERSTATE_ADD                                      = 10202;
//! ¼û״̬޸ʧ
const int TAPIERROR_USERSTATE_MOD                                      = 10203;
//! ¼û״̬ɾʧ
const int TAPIERROR_USERSTATE_DEL                                      = 10204;

//=============================================================================
//! ȨϢѯʧ
const int TAPIERROR_LICENSEINFO_QRY                                    = 10301;
//! ȨϢʧ
const int TAPIERROR_LICENSEINFO_ADD                                    = 10302;
//! ȨϢ޸ʧ
const int TAPIERROR_LICENSEINFO_MOD                                    = 10303;
//! ȨϢɾʧ
const int TAPIERROR_LICENSEINFO_DEL                                    = 10304;
//! ڹϢɾʧ
const int TAPIERROR_LICENSEINFO_IN_USERLICENSE_DEL                     = 10305;

//=============================================================================
//! ¼ûȨѯʧ
const int TAPIERROR_USERLICENSE_QRY                                    = 10401;
//! ¼ûȨʧ
const int TAPIERROR_USERLICENSE_ADD                                    = 10402;
//! ¼ûȨɾʧ
const int TAPIERROR_USERLICENSE_DEL                                    = 10403;

//=============================================================================
//! ȨϢѯʧ
const int TAPIERROR_RIGHTINFO_QRY                                      = 10501;

//=============================================================================
//! ɫϢѯʧ
const int TAPIERROR_ROLEINFO_QRY                                       = 10601;
//! ɫϢʧ
const int TAPIERROR_ROLEINFO_ADD                                       = 10602;
//! ɫϢ޸ʧ
const int TAPIERROR_ROLEINFO_MOD                                       = 10603;
//! ɫϢɾʧ
const int TAPIERROR_ROLEINFO_DEL                                       = 10604;
//! ڹϢɾʧ
const int TAPIERROR_ROLENO_IN_USERROLE_DEL                             = 10605;

//=============================================================================
//! ɫȨ޲ѯʧ
const int TAPIERROR_ROLERIGHT_QRY                                      = 10701;
//! ɫȨʧ
const int TAPIERROR_ROLERIGHT_ADD                                      = 10702;
//! ɫȨɾʧ
const int TAPIERROR_ROLERIGHT_DEL                                      = 10703;

//=============================================================================
//! ¼ûɫѯʧ
const int TAPIERROR_USERROLE_QRY                                       = 10801;
//! ¼ûɫʧ
const int TAPIERROR_USERROLE_ADD                                       = 10802;
//! ¼ûɫɾʧ
const int TAPIERROR_USERROLE_DEL                                       = 10803;

//=============================================================================
//! ¼ûȨ޲ѯʧ
const int TAPIERROR_USERRIGHT_QRY                                      = 10901;
//! ¼ûȨʧ
const int TAPIERROR_USERRIGHT_ADD                                      = 10902;
//! ¼ûȨɾʧ
const int TAPIERROR_USERRIGHT_DEL                                      = 10903;

//=============================================================================
//! ¼ûȨ޲ѯʧ
const int TAPIERROR_USERALLRIGHT_QRY                                   = 11001;
//! ¼ûȨ֪ͨʧ
const int TAPIERROR_USERALLRIGHT_ADD_NOTICE                            = 11002;
//! ¼ûȨɾ֪ͨʧ
const int TAPIERROR_USERALLRIGHT_DEL_NOTICE                            = 11003;

//=============================================================================
//! ˺ŷϢѯʧ
const int TAPIERROR_ACCOUNTGROUPINFO_QRY                               = 11101;
//! ˺ŷϢʧ
const int TAPIERROR_ACCOUNTGROUPINFO_ADD                               = 11102;
//! ˺ŷϢ޸ʧ
const int TAPIERROR_ACCOUNTGROUPINFO_MOD                               = 11103;
//! ˺ŷϢɾʧ
const int TAPIERROR_ACCOUNTGROUPINFO_DEL                               = 11104;

//=============================================================================
//! ˺ŷʽ˺Ųѯʧ
const int TAPIERROR_GROUPACCOUNT_QRY                                   = 11201;
//! ˺ŷʽ˺ʧ
const int TAPIERROR_GROUPACCOUNT_ADD                                   = 11202;
//! ˺ŷʽ˺ɾʧ
const int TAPIERROR_GROUPACCOUNT_DEL                                   = 11203;
//! ˺ŷʽ˺ʧܣ÷һͻֻܶӦһ
const int TAPIERROR_GROUPACCOUNT_ONETOONE                              = 11204;

//=============================================================================
//! ¼û˺ŷѯʧ
const int TAPIERROR_USERGROUP_QRY                                      = 11301;
//! ¼û˺ŷʧ
const int TAPIERROR_USERGROUP_ADD                                      = 11302;
//! ¼û˺ŷɾʧ
const int TAPIERROR_USERGROUP_DEL                                      = 11303;

//=============================================================================
//! ¼ûʽ˺Ųѯʧ
const int TAPIERROR_USERACCOUNT_QRY                                    = 11401;
//! ¼ûʽ˺ʧ
const int TAPIERROR_USERACCOUNT_ADD                                    = 11402;
//! ¼ûʽ˺ɾʧ
const int TAPIERROR_USERACCOUNT_DEL                                    = 11403;

//=============================================================================
//! ¼ûʽ˺Ųѯʧ
const int TAPIERROR_USERALLACCOUNT_QRY                                 = 11501;
//! ¼ûʽ˺֪ͨʧ
const int TAPIERROR_USERALLACCOUNT_ADD_NOTICE                          = 11502;
//! ¼ûʽ˺ɾ֪ͨʧ
const int TAPIERROR_USERALLACCOUNT_DEL_NOTICE                          = 11503;

//=============================================================================
//! Ϣѯʧ
const int TAPIERROR_PASSWORDTYPEINFO_QRY                               = 11601;
//! Ϣѯʧ
const int TAPIERROR_PASSWORDTYPEINFO_MOD                               = 11602;

//=============================================================================
//! ¼û޸ʧ
const int TAPIERROR_USERPASSWORD_MOD                                   = 11701;
//! ¼û޸ʧܡԭʼ
const int TAPIERROR_USERPASSWORD_MOD_SOURCE                            = 11702;
//! ¼û޸ʧܡǰnͬ
const int TAPIERROR_USERPASSWORD_MOD_SAME                              = 11703;
//! 벻븴ӶҪ
const int TAPIERROR_USERPASSWORD_MOD_COMPLEXITY                        = 11704;

//=============================================================================
//! Ϣѯʧ
const int TAPIERROR_LINKINFO_QRY                                       = 11801;
//! ϸϢѯʧ
const int TAPIERROR_LINKDETAILINFO_QRY                                 = 11802;
//! Ϣɾʧ
const int TAPIERROR_LINKINFO_DEL                                       = 11803;

//=============================================================================
//! ¼ûԤϢ޸ʧ
const int TAPIERROR_USERRESERVEDINFO_MOD                               = 11901;

//=============================================================================
//! ʶ¿ɵ¼ûбѯʧ
const int TAPIERROR_SERVERFLAGUSERS_QRY                                = 12001;
//! ʶ¿ɵ¼ûбʧ
const int TAPIERROR_SERVERFLAGUSERS_ADD                                = 12002;
//! ʶ¿ɵ¼ûбɾʧ
const int TAPIERROR_SERVERFLAGUSERS_DEL                                = 12003;

//=============================================================================
//! Ϣʧ
const int TAPIERROR_GROUPPROPERTYINFO_QRY                              = 12011;
//! Ϣʧ
const int TAPIERROR_GROUPPROPERTYINFO_ADD                              = 12012;
//! Ϣ޸ʧ
const int TAPIERROR_GROUPPROPERTYINFO_MOD                              = 12013;
//! Ϣɾʧ
const int TAPIERROR_GROUPPROPERTYINFO_DEL                              = 12014;

//=============================================================================
//! ڲ֤ʧ  
const int TAPIERROR_INTERFUTUREBANKPASSWORDAUTH_REQ                    = 12021;

//=============================================================================
//! ʽ˺޸ʧ  
const int TAPIERROR_ACCOUNTPASSWORD_MOD                                = 12031;
//! ʽ˺û޸ʧ  
const int TAPIERROR_ACCOUNTPASSWORDUSER_MOD                            = 12032;
//! ʽ˺޸ԭʼ
const int TAPIERROR_ACCOUNTPASSWORD_ERROR                              = 12033;
//=============================================================================
//! ʽ˺Ų
const int TAPIERROR_ORDERINSERT_ACCOUNT                                = 60001;
//! ʽ˺״̬ȷ
const int TAPIERROR_ORDERINSERT_ACCOUNT_STATE                          = 60002;

//! µЧĺԼ
const int TAPIERROR_ORDERINSERT_CONTRACT                               = 60011;

//! µԼ޽·
const int TAPIERROR_ORDERINSERT_TRADEROUTE                             = 60021;
//! ֲ
const int TAPIERROR_ORDERINSERT_POSITIONMAX                            = 60022;
//! ֹ
const int TAPIERROR_ORDER_NOTRADE                                      = 60023;
//! ֻƽ
const int TAPIERROR_ORDER_CLOSE                                        = 60024;
//! µʽ
const int TAPIERROR_ORDERINSERT_NOTENOUGHFUND                          = 60031;
//! ֵ֧Ķ
const int TAPIERROR_ORDERINSERT_ORDERTYPE                              = 60032;
//! ֵ֧ʱЧ
const int TAPIERROR_ORDERINSERT_TIMEINFORCE                            = 60033;
//! ֵ֧ĲԵ
const int TAPIERROR_ORDERINSERT_NO_TACTICS                             = 60034;
//! ƽгֲ
const int TAPIERROR_ORDERINSERT_POSITION_CANNOT_CLOSE                  = 60035;
//! µԶʧ
const int TAPIERROR_ORDERINSERT_AUTOCHECK_FAIL                         = 60036;
//! LMEδ׼
const int TAPIERROR_ORDERINSERT_LME_NOTREADY                           = 60037;
//! ƽַʽ
const int TAPIERROR_ORDERINSERT_CLOSEMODE                              = 60038;
//! µӦĸ˺ʽ
const int TAPIERROR_ORDERINSERT_PARENTNOTENOUGHFUND                    = 60039;
//! ĺԼʽ
const int TAPIERROR_SWAP_CONTRACT                                      = 60040;

//! ǰͻʹô˺Ž
const int TAPIERROR_USERNO_NOTHAS_ACCOUNT                              = 60051;
//! ͨ״̬
const int TAPIERROR_UPPERCHANNEL_BROKEN                                = 60052;
//! ͨδͨ
const int TAPIERROR_UPPERCHANNEL_NOT_EXIST                             = 60053;

//! ޴ϵͳ
const int TAPIERROR_ORDERDELETE_NOT_SYSNO                              = 60061;
//! ״̬
const int TAPIERROR_ORDERDELETE_NOT_STATE                              = 60062;
//! ״̬
const int TAPIERROR_ORDERACTIVE_NOT_STATE                              = 60063;

//! ״ֹ̬
const int TAPIERROR_ORDERCHECK_NOT_STATE                               = 60071;
//! ʧ
const int TAPIERROR_ORDERCHECK_FAIL                                    = 60072;

//! ״̬ĵ
const int TAPIERROR_ORDERMODIFY_NOT_STATE                              = 60081;
//! ˹ĵ
const int TAPIERROR_ORDERMODIFY_BACK_INPUT                             = 60082;

//! Ѳ
const int TAPIERROR_ORDERINSERT_FEE                                    = 60091;
//! ֤
const int TAPIERROR_ORDERINSERT_MARGIN                                 = 60092;

//! ˺ֻɲѯ
const int TAPIERROR_ORDER_NO_PERMIT                                    = 60100;

//! ̲Ӧ
const int TAPIERROR_RSPQUOTE_NO_PERMIT                                 = 60101;
//! ʹʺ̲Ӧ
const int TAPIERROR_RSPQUOTE_CHILD_NO_PERMIT                           = 60102;
//! µҲױ
const int TAPIERROR_TRADENO_NOT_FIND                                   = 60103;
//! ˺ֻɿ
const int TAPIERROR_ORDER_NO_CLOSE                                     = 60104;
//! ˺ûڹҵѯȨ
const int TAPIERROR_QRY_QUOTE_NO_PERMIT                                = 60105;
//=============================================================================
//! ֲѯʧ
const int TAPIERROR_CURRENCYINFO_QRY                                   = 20101;
//! ױֲѯʧ
const int TAPIERROR_TCURRENCYINFO_QRY                                  = 20102;
//! ʧ
const int TAPIERROR_CURRENCYINFO_ADD                                   = 20103;
//! ɾʧ
const int TAPIERROR_CURRENCYINFO_DEL                                   = 20104;
//! ޸ʧ
const int TAPIERROR_CURRENCYINFO_MOD                                   = 20105;
//! ּɾʧ
const int TAPIERROR_CURRENCYINFO_CASCADE_DEL                           = 20106;
//! ֻʱʷˮѯʧ
const int TAPIERROR_CURRENCYCHANGE_INFO_QRY                            = 20107;
//=============================================================================
//! ʽ˺Ϣѯʧ
const int TAPIERROR_ACCOUNTINFO_QRY                                    = 20201;
//! ʽ˺ժҪѯʧ
const int TAPIERROR_ACCOUNTSUMMARY_QRY                                 = 20202;
//! ʽ˺Ϣʧ
const int TAPIERROR_ACCOUNTINFO_ADD                                    = 20203;
//! ʽ˺Ϣɾʧ
const int TAPIERROR_ACCOUNTINFO_DEL                                    = 20204;
//! ʽ˺Ϣ޸ʧ
const int TAPIERROR_ACCOUNTINFO_MOD                                    = 20205;
//! ȫʽ˺Ϣѯʧ
const int TAPIERROR_ALLACCOUNTINFO_QRY                                 = 20206;
//=============================================================================
//! ͻϢѯʧ
const int TAPIERROR_ORGINFO_QRY                                        = 20301;
//! ͻϢʧ
const int TAPIERROR_ORGINFO_ADD                                        = 20302;
//! ͻϢɾʧ
const int TAPIERROR_ORGINFO_DEL                                        = 20303;
//! ͻϢ޸ʧ
const int TAPIERROR_ORGINFO_MOD                                        = 20304;

//=============================================================================
//! ͻ֤Ϣѯʧ
const int TAPIERROR_ACCOUNTCERTIFICATE_QRY                             = 20401;
//! ͻ֤Ϣʧ
const int TAPIERROR_ACCOUNTCERTIFICATE_ADD                             = 20402;
//! ͻ֤Ϣɾʧ
const int TAPIERROR_ACCOUNTCERTIFICATE_DEL                             = 20403;
//! ͻ֤Ϣ޸ʧ
const int TAPIERROR_ACCOUNTCERTIFICATE_MOD                             = 20404;

//=============================================================================
//! ͻʽ˺Ųѯʧ
const int TAPIERROR_PARENTACCOUNT_QRY                                  = 20501;
//! ͻʽ˺Ųѯʧ()
const int TAPIERROR_TPARENTACCOUNT_QRY                                 = 20502;
//! ͻʽ˺ʧ
const int TAPIERROR_PARENTACCOUNT_ADD                                  = 20503;
//! ͻʽ˺ɾʧ
const int TAPIERROR_PARENTACCOUNT_DEL                                  = 20504;
//! ͻʽ˺޸ʧ
const int TAPIERROR_PARENTACCOUNT_MOD                                  = 20505;

//=============================================================================
//! Ϣѯʧ
const int TAPIERROR_EXCHANGEINFO_QRY                                   = 20601;
//! Ϣʧ
const int TAPIERROR_EXCHANGEINFO_ADD                                   = 20602;
//! Ϣɾʧ
const int TAPIERROR_EXCHANGEINFO_DEL                                   = 20603;
//! Ϣ޸ʧ
const int TAPIERROR_EXCHANGEINFO_MOD                                   = 20604;

//=============================================================================
//! ͻױѯʧ
const int TAPIERROR_TRADENO_QRY                                        = 20701;
//! ͻױʧ
const int TAPIERROR_TRADENO_ADD                                        = 20702;
//! ͻױɾʧ
const int TAPIERROR_TRADENO_DEL                                        = 20703;
//! ͻױ޸ʧ
const int TAPIERROR_TRADENO_MOD                                        = 20704;
//! ͻױ˻Ѵ
const int TAPIERROR_TRADENO_EXIT                                       = 20705;

//=============================================================================
//! ͻϢѯʧ			
const int TAPIERROR_ACCOUNTBANKINFO_QRY                                = 20801;
//! ͻϢʧ			
const int TAPIERROR_ACCOUNTBANKINFO_ADD                                = 20802;
//! ͻϢɾʧ			
const int TAPIERROR_ACCOUNTBANKINFO_DEL                                = 20803;
//! ͻϢ޸ʧ			
const int TAPIERROR_ACCOUNTBANKINFO_MOD                                = 20804;

//=============================================================================
//! ϵϢѯʧ		
const int TAPIERROR_PARTYINFO_QRY                                      = 20901;
//! ϵϢʧ		
const int TAPIERROR_PARTYINFO_ADD                                      = 20902;
//! ϵϢɾʧ		
const int TAPIERROR_PARTYINFO_DEL                                      = 20903;
//! ϵϢ޸ʧ		
const int TAPIERROR_PARTYINFO_MOD                                      = 20904;

//=============================================================================
//! Ϣѯʧ
const int TAPIERROR_ATTRIBUTEINFO_QRY                                  = 21001;
//! Ϣʧ
const int TAPIERROR_ATTRIBUTEINFO_ADD                                  = 21002;
//! Ϣɾʧ
const int TAPIERROR_ATTRIBUTEINFO_DEL                                  = 21003;
//! Ϣ޸ʧ
const int TAPIERROR_ATTRIBUTEINFO_MOD                                  = 21004;

//=============================================================================
//! ͻϢѯʧ
const int TAPIERROR_ACCOUNTATTRIBUTE_QRY                               = 21101;
//! ͻϢʧ
const int TAPIERROR_ACCOUNTATTRIBUTE_ADD                               = 21102;
//! ͻϢ޸ʧ
const int TAPIERROR_ACCOUNTATTRIBUTE_MOD                               = 21103;

//=============================================================================
//! Ϣѯʧ
const int TAPIERROR_UPPERINFO_QRY                                      = 21201;
//! Ϣʧ
const int TAPIERROR_UPPERINFO_ADD                                      = 21202;
//! Ϣɾʧ
const int TAPIERROR_UPPERINFO_DEL                                      = 21203;
//! Ϣ޸ʧ
const int TAPIERROR_UPPERINFO_MOD                                      = 21204;
//! Ϣɾʧ
const int TAPIERROR_UPPERINFO_CASCADE_DEL                              = 21205;

//=============================================================================
//! Ϣѯʧ
const int TAPIERROR_UPPERBANKINFO_QRY                                  = 21301;
//! Ϣʧ
const int TAPIERROR_UPPERBANKINFO_ADD                                  = 21302;
//! Ϣɾʧ
const int TAPIERROR_UPPERBANKINFO_DEL                                  = 21303;
//! Ϣ޸ʧ
const int TAPIERROR_UPPERBANKINFO_MOD                                  = 21304;
//! Ϣɾʧ
const int TAPIERROR_UPPERBANKINFO_CASCADE_DEL                          = 21305;

//=============================================================================
//! ͨϢѯʧ
const int TAPIERROR_UPPERCHANNEL_QRY                                   = 21401;
//! ͨϢʧ
const int TAPIERROR_UPPERCHANNEL_ADD                                   = 21402;
//! ͨϢɾʧ
const int TAPIERROR_UPPERCHANNEL_DEL                                   = 21403;
//! ͨϢ޸ʧ
const int TAPIERROR_UPPERCHANNEL_MOD                                   = 21404;
//! ͨϢɾʧ
const int TAPIERROR_UPPERCHANNEL_CASCADE_DEL                           = 21405;

//=============================================================================
//! Ϣѯʧ
const int TAPIERROR_CURRENCYGROUP_QRY                                  = 21501;
//! Ϣʧ
const int TAPIERROR_CURRENCYGROUP_ADD                                  = 21502;
//! Ϣɾʧ
const int TAPIERROR_CURRENCYGROUP_DEL                                  = 21503;
//! Ϣ޸ʧ
const int TAPIERROR_CURRENCYGROUP_MOD                                  = 21504;
//! ϢڱϢɾʧ
const int TAPIERROR_CURRENCYGROUP_CASCADE_DEL                          = 21505;

//=============================================================================
//! бʶѯʧ
const int TAPIERROR_BANKINFO_QRY                                       = 21601;
//! бʶʧ
const int TAPIERROR_BANKINFO_ADD                                       = 21602;
//! бʶɾʧ
const int TAPIERROR_BANKINFO_DEL                                       = 21603;
//! бʶ޸ʧ
const int TAPIERROR_BANKINFO_MOD                                       = 21604;
//! бʶϢڼɾʧ
const int TAPIERROR_BANKINFO_CASCADE_DEL                               = 21605;

//=============================================================================
//! ˾Ϣѯʧ
const int TAPIERROR_INTERNALBANK_QRY                                   = 21701;
//! ˾Ϣʧ
const int TAPIERROR_INTERNALBANK_ADD                                   = 21702;
//! ˾Ϣɾʧ
const int TAPIERROR_INTERNALBANK_DEL                                   = 21703;
//! ˾Ϣ޸ʧ
const int TAPIERROR_INTERNALBANK_MOD                                   = 21704;

//=============================================================================
//! һʲѯʧ
const int TAPIERROR_SWAPRATE_QRY                                       = 21801;
//! һʧ
const int TAPIERROR_SWAPRATE_ADD                                       = 21802;
//! һɾʧ
const int TAPIERROR_SWAPRATE_DEL                                       = 21803;
//! һ޸ʧ
const int TAPIERROR_SWAPRATE_MOD                                       = 21804;

//=============================================================================
//! ͻȲѯʧ
const int TAPIERROR_ACCOUNTSWAPVALUE_QRY                               = 21901;
//! ͻʧ
const int TAPIERROR_ACCOUNTSWAPVALUE_ADD                               = 21902;
//! ͻɾʧ
const int TAPIERROR_ACCOUNTSWAPVALUE_DEL                               = 21903;
//! ͻ޸ʧ
const int TAPIERROR_ACCOUNTSWAPVALUE_MOD                               = 21904;

//=============================================================================
//! ƷϢѯʧ
const int TAPIERROR_COMMODITYINFO_QRY                                  = 22001;
//! ƷϢѯʧ()
const int TAPIERROR_TCOMMODITYINFO_QRY                                 = 22002;
//! ƷϢʧ
const int TAPIERROR_COMMODITYINFO_ADD                                  = 22003;
//! ƷϢɾʧ
const int TAPIERROR_COMMODITYINFO_DEL                                  = 22004;
//! ƷϢ޸ʧ
const int TAPIERROR_COMMODITYINFO_MOD                                  = 22005;

//=============================================================================
//! Ʒְѯʧ
const int TAPIERROR_COMMODITYSECTOR_QRY                                = 22101;
//! Ʒְʧ
const int TAPIERROR_COMMODITYSECTOR_ADD                                = 22102;
//! Ʒְɾʧ
const int TAPIERROR_COMMODITYSECTOR_DEL                                = 22103;
//! Ʒְ޸ʧ
const int TAPIERROR_COMMODITYSECTOR_MOD                                = 22104;
//! ƷְӳƷּɾʧ
const int TAPIERROR_COMMODITYSECTOR_CASCADE_DEL                        = 22105;
//! ƷְƷְɾʧ
const int TAPIERROR_COMMODITYSECTOR_CHILD_DEL                          = 22106;

//=============================================================================
//! ƷְӦƷֲѯʧ
const int TAPIERROR_SECTORMAPCOMMODITY_QRY                             = 22201;
//! ƷְӦƷʧ
const int TAPIERROR_SECTORMAPCOMMODITY_ADD                             = 22202;
//! ƷְӦƷɾʧ
const int TAPIERROR_SECTORMAPCOMMODITY_DEL                             = 22203;
//! ƷְӦƷ޸ʧ
const int TAPIERROR_SECTORMAPCOMMODITY_MOD                             = 22204;

//=============================================================================
//! Ʒѯʧ
const int TAPIERROR_COMMODITYGROUP_QRY                                 = 22301;
//! Ʒʧ
const int TAPIERROR_COMMODITYGROUP_ADD                                 = 22302;
//! Ʒɾʧ
const int TAPIERROR_COMMODITYGROUP_DEL                                 = 22303;
//! Ʒ޸ʧ
const int TAPIERROR_COMMODITYGROUP_MOD                                 = 22304;
//! Ʒ鼶ɾʧ
const int TAPIERROR_COMMODITYGROUP_CASCADE_DEL                         = 22305;

//=============================================================================
//! ӦƷֲѯʧ
const int TAPIERROR_GROUPMAPCOMMODITY_QRY                              = 22401;
//! ӦƷʧ
const int TAPIERROR_GROUPMAPCOMMODITY_ADD                              = 22402;
//! ӦƷɾʧ
const int TAPIERROR_GROUPMAPCOMMODITY_DEL                              = 22403;
//! ӦƷ޸ʧ
const int TAPIERROR_GROUPMAPCOMMODITY_MOD                              = 22404;

//=============================================================================
//! ʱģѯʧ
const int TAPIERROR_TRADINGTIMEBUCKET_QRY                              = 22501;
//! ʱģʧ
const int TAPIERROR_TRADINGTIMEBUCKET_ADD                              = 22502;
//! ʱģɾʧ
const int TAPIERROR_TRADINGTIMEBUCKET_DEL                              = 22503;
//! ʱģ޸ʧ
const int TAPIERROR_TRADINGTIMEBUCKET_MOD                              = 22504;

//=============================================================================
//! ƷϢѯʧ
const int TAPIERROR_COMMODITYQUOTEINFO_QRY                             = 22601;
//! ƷϢʧ
const int TAPIERROR_COMMODITYQUOTEINFO_ADD                             = 22602;
//! ƷϢɾʧ
const int TAPIERROR_COMMODITYQUOTEINFO_DEL                             = 22603;
//! ƷϢ޸ʧ
const int TAPIERROR_COMMODITYQUOTEINFO_MOD                             = 22604;

//=============================================================================
//! ƷֹϢѯʧ
const int TAPIERROR_COMMODITYRELATEINFO_QRY                            = 22701;
//! ƷֹϢʧ
const int TAPIERROR_COMMODITYRELATEINFO_ADD                            = 22702;
//! ƷֹϢɾʧ
const int TAPIERROR_COMMODITYRELATEINFO_DEL                            = 22703;
//! ƷֹϢ޸ʧ
const int TAPIERROR_COMMODITYRELATEINFO_MOD                            = 22704;

//=============================================================================
//! ԼϢѯʧ
const int TAPIERROR_CONTRACTINFO_QRY                                   = 22801;
//! ԼϢʧ
const int TAPIERROR_CONTRACTINFO_ADD                                   = 22802;
//! ԼϢɾʧ
const int TAPIERROR_CONTRACTINFO_DEL                                   = 22803;
//! ԼϢ޸ʧ
const int TAPIERROR_CONTRACTINFO_MOD                                   = 22804;
//! ԼϢгֲּɾʧ
const int TAPIERROR_CONTRACTINFO_CASCADE_DEL                           = 22805;

//=============================================================================
//! ȨĲѯʧ
const int TAPIERROR_SPECIALOPTIONFUTURE_QRY                            = 22901;
//! Ȩʧ
const int TAPIERROR_SPECIALOPTIONFUTURE_ADD                            = 22902;
//! Ȩɾʧ
const int TAPIERROR_SPECIALOPTIONFUTURE_DEL                            = 22903;
//! Ȩ޸ʧ
const int TAPIERROR_SPECIALOPTIONFUTURE_MOD                            = 22904;

//=============================================================================
//! Ʒִӳѯʧ
const int TAPIERROR_UPPERCOMMODITYMAPPING_QRY                          = 23001;
//! Ʒִӳʧ
const int TAPIERROR_UPPERCOMMODITYMAPPING_ADD                          = 23002;
//! Ʒִӳɾʧ
const int TAPIERROR_UPPERCOMMODITYMAPPING_DEL                          = 23003;
//! Ʒִӳ޸ʧ
const int TAPIERROR_UPPERCOMMODITYMAPPING_MOD                          = 23004;

//=============================================================================
//! ⲿƷִӳѯʧ
const int TAPIERROR_OUTSIDECOMMODITYMAPPING_QRY                        = 23101;
//! ⲿƷִӳʧ
const int TAPIERROR_OUTSIDECOMMODITYMAPPING_ADD                        = 23102;
//! ⲿƷִӳɾʧ
const int TAPIERROR_OUTSIDECOMMODITYMAPPING_DEL                        = 23103;
//! ⲿƷִӳ޸ʧ
const int TAPIERROR_OUTSIDECOMMODITYMAPPING_MOD                        = 23104;

//=============================================================================
//! ⲿԴѯʧ
const int TAPIERROR_OUTSIDEDATASOURCE_QRY                              = 23201;
//! ⲿԴʧ
const int TAPIERROR_OUTSIDEDATASOURCE_ADD                              = 23202;
//! ⲿԴɾʧ
const int TAPIERROR_OUTSIDEDATASOURCE_DEL                              = 23203;
//! ⲿԴ޸ʧ
const int TAPIERROR_OUTSIDEDATASOURCE_MOD                              = 23204;

//=============================================================================
//! Ѳѯʧ
const int TAPIERROR_UPPERFEE_QRY                                       = 23301;
//! ʧ
const int TAPIERROR_UPPERFEE_ADD                                       = 23302;
//! ɾʧ
const int TAPIERROR_UPPERFEE_DEL                                       = 23303;
//! ޸ʧ
const int TAPIERROR_UPPERFEE_MOD                                       = 23304;

//=============================================================================
//! ģѯʧ
const int TAPIERROR_TEMPLATEFEE_QRY                                    = 23401;
//! ģʧ
const int TAPIERROR_TEMPLATEFEE_ADD                                    = 23402;
//! ģɾʧ
const int TAPIERROR_TEMPLATEFEE_DEL                                    = 23403;
//! ģ޸ʧ
const int TAPIERROR_TEMPLATEFEE_MOD                                    = 23404;

//=============================================================================
//! ͻӦģѯʧ
const int TAPIERROR_ACCOUNTFEETEMPLATE_QRY                             = 23501;
//! ͻӦģʧ
const int TAPIERROR_ACCOUNTFEETEMPLATE_ADD                             = 23502;
//! ͻӦģɾʧ
const int TAPIERROR_ACCOUNTFEETEMPLATE_DEL                             = 23503;
//! ͻӦģ޸ʧ
const int TAPIERROR_ACCOUNTFEETEMPLATE_MOD                             = 23504;

//=============================================================================
//! òѯʧ
const int TAPIERROR_UPPEROTHERFEE_QRY                                  = 23601;
//! ʧ
const int TAPIERROR_UPPEROTHERFEE_ADD                                  = 23602;
//! ɾʧ
const int TAPIERROR_UPPEROTHERFEE_DEL                                  = 23603;
//! ޸ʧ
const int TAPIERROR_UPPEROTHERFEE_MOD                                  = 23604;

//=============================================================================
//! ͻòѯʧ
const int TAPIERROR_ACCOUNTOTHERFEE_QRY                                = 23701;
//! ͻʧ
const int TAPIERROR_ACCOUNTOTHERFEE_ADD                                = 23702;
//! ͻɾʧ
const int TAPIERROR_ACCOUNTOTHERFEE_DEL                                = 23703;
//! ͻ޸ʧ
const int TAPIERROR_ACCOUNTOTHERFEE_MOD                                = 23704;

//=============================================================================
//! ֱ֤ѯʧ
const int TAPIERROR_UPPERMARGIN_QRY                                    = 23801;
//! ֱ֤ʧ
const int TAPIERROR_UPPERMARGIN_ADD                                    = 23802;
//! ֱ֤ɾʧ
const int TAPIERROR_UPPERMARGIN_DEL                                    = 23803;
//! ֱ֤޸ʧ
const int TAPIERROR_UPPERMARGIN_MOD                                    = 23804;

//=============================================================================
//! ֱ֤ѯʧ
const int TAPIERROR_UPPERMARGINADJUST_QRY                              = 23901;
//! ֱ֤ʧ
const int TAPIERROR_UPPERMARGINADJUST_ADD                              = 23902;
//! ֱ֤ɾʧ
const int TAPIERROR_UPPERMARGINADJUST_DEL                              = 23903;
//! ֱ֤޸ʧ
const int TAPIERROR_UPPERMARGINADJUST_MOD                              = 23904;

//=============================================================================
//! ֤ģѯʧ
const int TAPIERROR_TEMPLATEMARGIN_QRY                                 = 24001;
//! ֤ģʧ
const int TAPIERROR_TEMPLATEMARGIN_ADD                                 = 24002;
//! ֤ģɾʧ
const int TAPIERROR_TEMPLATEMARGIN_DEL                                 = 24003;
//! ֤ģ޸ʧ
const int TAPIERROR_TEMPLATEMARGIN_MOD                                 = 24004;

//=============================================================================
//! ͻӦ֤ģѯʧ
const int TAPIERROR_ACCOUNTMARGINTEMPLATE_QRY                          = 24101;
//! ͻӦ֤ģʧ
const int TAPIERROR_ACCOUNTMARGINTEMPLATE_ADD                          = 24102;
//! ͻӦ֤ģɾʧ
const int TAPIERROR_ACCOUNTMARGINTEMPLATE_DEL                          = 24103;
//! ͻӦ֤ģ޸ʧ
const int TAPIERROR_ACCOUNTMARGINTEMPLATE_MOD                          = 24104;

//=============================================================================
//! ֤ģѯʧ
const int TAPIERROR_TEMPLATEMARGINADJUST_QRY                           = 24201;
//! ֤ģʧ
const int TAPIERROR_TEMPLATEMARGINADJUST_ADD                           = 24202;
//! ֤ģɾʧ
const int TAPIERROR_TEMPLATEMARGINADJUST_DEL                           = 24203;
//! ֤ģ޸ʧ
const int TAPIERROR_TEMPLATEMARGINADJUST_MOD                           = 24204;

//=============================================================================
//! ֱѯʧ
const int TAPIERROR_LOCKEDPERCENTAGE_QRY                               = 24301;
//! ֱʧ
const int TAPIERROR_LOCKEDPERCENTAGE_ADD                               = 24302;
//! ֱɾʧ
const int TAPIERROR_LOCKEDPERCENTAGE_DEL                               = 24303;
//! ֱ޸ʧ
const int TAPIERROR_LOCKEDPERCENTAGE_MOD                               = 24304;

//=============================================================================
//! Ȩ޲ѯʧ
const int TAPIERROR_TRADINGRIGHT_QRY                                   = 24401;
//! Ȩʧ
const int TAPIERROR_TRADINGRIGHT_ADD                                   = 24402;
//! Ȩɾʧ
const int TAPIERROR_TRADINGRIGHT_DEL                                   = 24403;
//! Ȩ޸ʧ
const int TAPIERROR_TRADINGRIGHT_MOD                                   = 24404;

//=============================================================================
//! µѯʧ
const int TAPIERROR_ONCEMAX_QRY                                        = 24501;
//! µʧ
const int TAPIERROR_ONCEMAX_ADD                                        = 24502;
//! µɾʧ
const int TAPIERROR_ONCEMAX_DEL                                        = 24503;
//! µ޸ʧ
const int TAPIERROR_ONCEMAX_MOD                                        = 24504;

//=============================================================================
//! ֲѯʧ
const int TAPIERROR_POSITIONMAX_QRY                                    = 24601;
//! ֲʧ
const int TAPIERROR_POSITIONMAX_ADD                                    = 24602;
//! ֲɾʧ
const int TAPIERROR_POSITIONMAX_DEL                                    = 24603;
//! ֲ޸ʧ
const int TAPIERROR_POSITIONMAX_MOD                                    = 24604;

//=============================================================================
//! ·ɿƲѯʧ
const int TAPIERROR_TRADINGROUTE_QRY                                   = 24701;
//! ·ɿʧ
const int TAPIERROR_TRADINGROUTE_ADD                                   = 24702;
//! ·ɿɾʧ
const int TAPIERROR_TRADINGROUTE_DEL                                   = 24703;
//! ·ɿ޸ʧ
const int TAPIERROR_TRADINGROUTE_MOD                                   = 24704;

//=============================================================================
//! ·ɿƲѯʧ
const int TAPIERROR_QUOTEROUTE_QRY                                     = 24801;
//! ·ɿʧ
const int TAPIERROR_QUOTEROUTE_ADD                                     = 24802;
//! ·ɿɾʧ
const int TAPIERROR_QUOTEROUTE_DEL                                     = 24803;
//! ·ɿ޸ʧ
const int TAPIERROR_QUOTEROUTE_MOD                                     = 24804;

//=============================================================================
//! ϵͳѯʧ
const int TAPIERROR_SYSTEMPARAMETER_QRY                                = 24901;
//! ϵͳʧ
const int TAPIERROR_SYSTEMPARAMETER_ADD                                = 24902;
//! ϵͳɾʧ
const int TAPIERROR_SYSTEMPARAMETER_DEL                                = 24903;
//! ϵͳ޸ʧ
const int TAPIERROR_SYSTEMPARAMETER_MOD                                = 24904;

//=============================================================================
//! ĿϢѯʧ
const int TAPIERROR_ITEMINFO_QRY                                       = 25001;
//! ĿֵϢ޸ʧ
const int TAPIERROR_ITEMVALUEINFO_QRY                                  = 25002;

//=============================================================================
//! ģϢѯʧ
const int TAPIERROR_TEMPLATEFEEINFO_QRY                                = 25101;
//! ģϢʧ
const int TAPIERROR_TEMPLATEFEEINFO_ADD                                = 25102;
//! ģϢɾʧ
const int TAPIERROR_TEMPLATEFEEINFO_DEL                                = 25103;
//! ģϢ޸ʧ
const int TAPIERROR_TEMPLATEFEEINFO_MOD                                = 25104;
//! ģϢɾʧ
const int TAPIERROR_TEMPLATEFEEINFO_CASCADE_DEL                        = 25105;

//=============================================================================
//! ֤ģϢѯʧ
const int TAPIERROR_TEMPLATEMARGININFO_QRY                             = 25201;
//! ֤ģϢʧ
const int TAPIERROR_TEMPLATEMARGININFO_ADD                             = 25202;
//! ֤ģϢɾʧ
const int TAPIERROR_TEMPLATEMARGININFO_DEL                             = 25203;
//! ֤ģϢ޸ʧ
const int TAPIERROR_TEMPLATEMARGININFO_MOD                             = 25204;
//! ֤ģϢɾʧ
const int TAPIERROR_TEMPLATEMARGININFO_CASCADE_DEL                     = 25205;

//=============================================================================
//! Ϣѯʧ
const int TAPIERROR_OTHERFEETYPEINFO_QRY                               = 25301;
//! Ϣʧ
const int TAPIERROR_OTHERFEETYPEINFO_ADD                               = 25302;
//! Ϣɾʧ
const int TAPIERROR_OTHERFEETYPEINFO_DEL                               = 25303;
//! Ϣ޸ʧ
const int TAPIERROR_OTHERFEETYPEINFO_MOD                               = 25304;
//! Ϣɾʧ
const int TAPIERROR_OTHERFEETYPEINFO_CASCADE_DEL                       = 25305;

//=============================================================================
//! ƷίͲѯʧ
const int TAPIERROR_COMMODITYORDERTYPE_QRY                             = 25501;
//! Ʒίʧ
const int TAPIERROR_COMMODITYORDERTYPE_ADD                             = 25502;
//! Ʒίɾʧ
const int TAPIERROR_COMMODITYORDERTYPE_DEL                             = 25503;
//! Ʒί޸ʧ
const int TAPIERROR_COMMODITYORDERTYPE_MOD                             = 25504;

//=============================================================================
//! ƷίʱЧԲѯʧ
const int TAPIERROR_ORDERTIMEINFORCE_QRY                               = 25601;
//! ƷίʱЧʧ
const int TAPIERROR_ORDERTIMEINFORCE_ADD                               = 25602;
//! ƷίʱЧɾʧ
const int TAPIERROR_ORDERTIMEINFORCE_DEL                               = 25603;
//! ƷίʱЧ޸ʧ
const int TAPIERROR_ORDERTIMEINFORCE_MOD                               = 25604;

//=============================================================================
//! ԼϢѯʧ
const int TAPIERROR_ATTRIBUTELEVELINFO_QRY                             = 25701;
//! ԼϢʧ
const int TAPIERROR_ATTRIBUTELEVELINFO_ADD                             = 25702;
//! ԼϢɾʧ
const int TAPIERROR_ATTRIBUTELEVELINFO_DEL                             = 25703;
//! ԼϢ޸ʧ
const int TAPIERROR_ATTRIBUTELEVELINFO_MOD                             = 25704;
//! ԼϢɾʧ
const int TAPIERROR_ATTRIBUTELEVELINFO_CASCADE_DEL                     = 25705;

//=============================================================================
//! ģϢѯʧ
const int TAPIERROR_CALENDARTEMPLATEINFO_QRY                           = 25801;
//! ģϢʧ
const int TAPIERROR_CALENDARTEMPLATEINFO_ADD                           = 25802;
//! ģϢɾʧ
const int TAPIERROR_CALENDARTEMPLATEINFO_DEL                           = 25803;
//! ģϢ޸ʧ
const int TAPIERROR_CALENDARTEMPLATEINFO_MOD                           = 25804;

//=============================================================================
//! Ʒֽģѯʧ
const int TAPIERROR_COMMODITYCALENDARTEMPLATE_QRY                      = 25901;
//! Ʒֽģʧ
const int TAPIERROR_COMMODITYCALENDARTEMPLATE_ADD                      = 25902;
//! Ʒֽģɾʧ
const int TAPIERROR_COMMODITYCALENDARTEMPLATE_DEL                      = 25903;
//! Ʒֽģ޸ʧ
const int TAPIERROR_COMMODITYCALENDARTEMPLATE_MOD                      = 25904;

//=============================================================================
//! ʵֵѯʧ
const int TAPIERROR_ACCOUNTREALVALUE_QRY                               = 26001;
//! ʵֵʧ
const int TAPIERROR_ACCOUNTREALVALUE_ADD                               = 26002;
//! ʵֵɾʧ
const int TAPIERROR_ACCOUNTREALVALUE_DEL                               = 26003;
//! ʵֵ޸ʧ
const int TAPIERROR_ACCOUNTREALVALUE_MOD                               = 26004;

//=============================================================================
//! ԶȨʧ
const int TAPIERROR_TOOPTIONCMB_REQ                                    = 26101;

//=============================================================================
//! ģϢѯʧ
const int TAPIERROR_CALENDARTEMPLATEBASE_QRY                           = 26201;
//! ģϢʧ
const int TAPIERROR_CALENDARTEMPLATEBASE_ADD                           = 26202;
//! ģϢɾʧ
const int TAPIERROR_CALENDARTEMPLATEBASE_DEL                           = 26203;
//! ģϢ޸ʧ
const int TAPIERROR_CALENDARTEMPLATEBASE_MOD                           = 26204;

//----------------˻֤ʹ붨-------------------------------------
//=============================================================================
//! ˻֤Ͳѯʧ
const int TAPIERROR_CERTIFICATE_QRY                                    = 26301;

//=============================================================================
//! ʶѯʧ
const int TAPIERROR_TRADESERVERFLAG_QRY                                = 26401;
//! ʶʧ
const int TAPIERROR_TRADESERVERFLAG_ADD                                = 26402;
//! ʶɾʧ
const int TAPIERROR_TRADESERVERFLAG_DEL                                = 26403;
//! ʶ޸ʧ
const int TAPIERROR_TRADESERVERFLAG_MOD                                = 26404;
//! ʶɾʧ
const int TAPIERROR_TRADESERVERFLAG_CASCADE_DEL                        = 26405;

//=============================================================================
//! ʶӳʽ˺ŶӦѲѯʧ
const int TAPIERROR_TRADESERVERFLAG_FEETEMPLATE_QRY                    = 26501;

//=============================================================================
//! ʶӳʽ˺ŶӦ֤ѯʧ
const int TAPIERROR_TRADESERVERFLAG_MARGINTEMPLATE_QRY                 = 26601;

//=============================================================================
//! ʶӳʽ˺ŶӦϢѯʧ
const int TAPIERROR_TRADESERVERFLAG_ACCOUNT_FEEINFO_QRY                = 26701;

//=============================================================================
//! ʶӳʽ˺ŶӦ֤Ϣѯʧ
const int TAPIERROR_TRADESERVERFLAG_ACCOUNT_MARGININFO_QRY             = 26801;

//=============================================================================
//! Ϣѯʧ
const int TAPIERROR_COUNTY_QRY                                         = 26901;

//=============================================================================
//! ʡϢѯʧ
const int TAPIERROR_PROVINCE_QRY                                       = 27001;
//=============================================================================
//! ǩǩ˲ѯʧ
const int TAPIERROR_BANKLOGINOUT_QRY                                   = 27101;
//! ǩǩʧ
const int TAPIERROR_BANKLOGINOUT_ADD                                   = 27102;

//=============================================================================
//! ˮѯʧ
const int TAPIERROR_TRANSFERFUTUREBANK_QRY                             = 27201;
//! ˮʧ
const int TAPIERROR_TRANSFERFUTUREBANK_ADD                             = 27202;

//=============================================================================
//! ת˲ѯʧ
const int TAPIERROR_TRANSFERRENT_QRY                                   = 27301;
//! ת˲ʧ
const int TAPIERROR_TRANSFERRENT_ADD                                   = 27302;
//! ת˲޸ʧ
const int TAPIERROR_TRANSFERRENT_MOD                                   = 27303;
//! ת˲ɾʧ
const int TAPIERROR_TRANSFERRENT_DEL                                   = 27304;

//=============================================================================
//! תʱβѯʧ
const int TAPIERROR_TRANSFERTIME_QRY                                   = 27401;
//! תʱʧ
const int TAPIERROR_TRANSFERTIME_ADD                                   = 27402;
//! תʱ޸ʧ
const int TAPIERROR_TRANSFERTIME_MOD                                   = 27403;
//! תʱɾʧ
const int TAPIERROR_TRANSFERTIME_DEL                                   = 27404;

//=============================================================================
//! תǩԼʷˮѯʧ
const int TAPIERROR_BANKSIGNEDINFO_QRY                                 = 27501;
//! תǩԼʷˮʧ
const int TAPIERROR_BANKSIGNEDINFO_ADD                                 = 27502;

//=============================================================================
//! ʱģѯʧ
const int TAPIERROR_TRADINGTIMEBUCKETBASE_QRY                          = 27601;
//! ʱģʧ
const int TAPIERROR_TRADINGTIMEBUCKETBASE_ADD                          = 27602;
//! ʱģɾʧ
const int TAPIERROR_TRADINGTIMEBUCKETBASE_DEL                          = 27603;
//! ʱģ޸ʧ
const int TAPIERROR_TRADINGTIMEBUCKETBASE_MOD                          = 27604;
//! ʱģɾʧ
const int TAPIERROR_TRADINGTIMEBUCKETBASE_CASCADE_DEL                  = 27605;
//=============================================================================
//! Ϣѯʧ
const int TAPIERROR_CLASSIFY_QRY                                       = 27701;

//=============================================================================
//! ֯Ϣѯʧ
const int TAPIERROR_ORGANTYPE_QRY                                      = 27801;

//=============================================================================
//! 9.0ϵͳϢѯʧ
const int TAPIERROR_TRADINGCALENDARINFO_QRY                            = 27901;
//! 9.0ϵͳϢʧ
const int TAPIERROR_TRADINGCALENDARINFO_ADD                            = 27902;
//! 9.0ϵͳϢ޸ʧ
const int TAPIERROR_TRADINGCALENDARINFO_MOD                            = 27903;
//! 9.0ϵͳϢɾʧ
const int TAPIERROR_TRADINGCALENDARINFO_DEL                            = 27904;
//! ͨѯǰպϴνղѯʧ
const int TAPIERROR_TRADING_CLENDAR_SETTLE_TRADE_QRY                   = 27905;

//=============================================================================
//! ֹϢѯʧ
const int TAPIERROR_EXCHANGETRADINGCALENDARINFO_QRY                    = 28001;
//! ֹϢʧ
const int TAPIERROR_EXCHANGETRADINGCALENDARINFO_ADD                    = 28002;
//! ֹϢ޸ʧ
const int TAPIERROR_EXCHANGETRADINGCALENDARINFO_MOD                    = 28003;
//! ֹϢɾʧ
const int TAPIERROR_EXCHANGETRADINGCALENDARINFO_DEL                    = 28004;
//! ݽղѯϸڲѯʧ
const int TAPIERROR_EXCHANGE_TRADING_DETAILDATE_QRY                    = 28005;

//=============================================================================
//! ԼʱϢѯʧ
const int TAPIERROR_CONTRACTNEARDELIVERY_QRY                           = 28101;
//! ԼʱϢʧ
const int TAPIERROR_CONTRACTNEARDELIVERY_ADD                           = 28102;
//! ԼʱϢɾʧ
const int TAPIERROR_CONTRACTNEARDELIVERY_DEL                           = 28103;
//=============================================================================
//! Ϣѯʧ
const int TAPIERROR_CHECKTABLEINFO_QRY                                 = 28201;
//! Ϣʧ
const int TAPIERROR_CHECKTABLEINFO_ADD                                 = 28202;
//! Ϣ޸ʧ
const int TAPIERROR_CHECKTABLEINFO_MOD                                 = 28203;
//! Ϣɾʧ
const int TAPIERROR_CHECKTABLEINFO_DEL                                 = 28204;
//! жǷΪ˱ѯʧ
const int TAPIERROR_CHECKTABLEBASEINFO_QRY                             = 28205;
//! ɾϢѯʧ
const int TAPIERROR_CHECKTABLEDELINFO_QRY                              = 28206;
//! ɾϢʧ
const int TAPIERROR_CHECKTABLEDELINFO_ADD                              = 28207;
//! ɾϢɾʧ
const int TAPIERROR_CHECKTABLEDELINFO_DEL                              = 28208;
//! ˻Ϣʧ
const int TAPIERROR_CHECKTABLEBASEINFO_ADD                             = 28209;
//! ˻Ϣ޸ʧ
const int TAPIERROR_CHECKTABLEBASEINFO_MOD                             = 28210;

//=============================================================================
//! ־ѯʧ
const int TAPIERROR_OPERATORLOGINFO_QRY                                = 28301;
//! ־ʧ
const int TAPIERROR_OPERATORLOGINFO_ADD                                = 28302;
//! ־ɾʧ
const int TAPIERROR_OPERATORLOGINFO_DEL                                = 28303;

//! ղѯʧ
const int TAPIERROR_RISKPARAMETER_QRY                                  = 28304;
//! ղ޸ʧ
const int TAPIERROR_RISKPARAMETER_MOD                                  = 28305;

//! ѯʧ
const int TAPIERROR_TRANSFERCOUNTVALUE_QRY                             = 28306;
//! ʧ
const int TAPIERROR_TRANSFERCOUNTVALUE_ADD                             = 28307;
//=============================================================================
//! ֹԶ˶ѯʧ
const int TAPIERROR_BANAUTO_ORDERCHECK_QRY                             = 28401;
//! ֹԶ˶ʧ
const int TAPIERROR_BANAUTO_ORDERCHECK_ADD                             = 28402;
//! ֹԶ˶ɾʧ
const int TAPIERROR_BANAUTO_ORDERCHECK_DEL                             = 28403;
//=============================================================================
//! ʽ˺ŶӦԼѯʧ
const int TAPIERROR_USER_QUOTE_QTY_QRY                                 = 28501;
//! ʽ˺ŶӦԼʧ
const int TAPIERROR_USER_QUOTE_QTY_ADD                                 = 28502;
//! ʽ˺ŶӦԼ޸ʧ
const int TAPIERROR_USER_QUOTE_QTY_MOD                                 = 28503;
//! ʽ˺ŶӦԼɾʧ
const int TAPIERROR_USER_QUOTE_QTY_DEL                                 = 28504;
//=============================================================================
//! Ʒְѯʧ
const int TAPIERROR_SECTOR_PARENT_QRY                                  = 28601;
//! Ʒְʧ
const int TAPIERROR_SECTOR_PARENT_ADD                                  = 28602;
//! Ʒְ޸ʧ
const int TAPIERROR_SECTOR_PARENT_MOD                                  = 28603;
//! Ʒְɾʧ
const int TAPIERROR_SECTOR_PARENT_DEL                                  = 28604;
//=============================================================================
//! λϢѯʧ
const int TAPIERROR_MEASURE_UNIT_QRY                                   = 28701;
//! λϵϢѯʧ
const int TAPIERROR_MEASURE_CONVERSION_QRY                             = 28702;
//! Ƽ۵λϵϢѯʧ
const int TAPIERROR_CHARGE_CONVERSION_QRY                              = 28703;

//=============================================================================
//! Ƽ۵λϢѯʧ
const int TAPIERROR_CHARGE_UNIT_QRY                                    = 28801;
//! Ƽ۵λϢʧ
const int TAPIERROR_CHARGE_UNIT_ADD                                    = 28802;
//! Ƽ۵λϢ޸ʧ
const int TAPIERROR_CHARGE_UNIT_MOD                                    = 28803;
//! ƼλϢɾʧ
const int TAPIERROR_CHARGE_UNIT_DEL                                    = 28804;
//=============================================================================
//! ûµƵʲѯʧ
const int TAPIERROR_USER_ORDER_FREQUENCE_QRY                           = 28901;
//! ûµƵʧ
const int TAPIERROR_USER_ORDER_FREQUENCE_ADD                           = 28902;
//! ûµƵ޸ʧ
const int TAPIERROR_USER_ORDER_FREQUENCE_MOD                           = 28903;
//! ûµƵɾʧ
const int TAPIERROR_USER_ORDER_FREQUENCE_DEL                           = 28904;
//=============================================================================
//! Ӳѯʧ
const int TAPIERROR_DATA_LINKINFO_QRY                                  = 29001;
//! ʧ
const int TAPIERROR_DATA_LINKINFO_ADD                                  = 29002;
//! ޸ʧ
const int TAPIERROR_DATA_LINKINFO_MOD                                  = 29003;
//! ɾʧ
const int TAPIERROR_DATA_LINKINFO_DEL                                  = 29004;
//=============================================================================
//! ֻƽǰѯʧ
const int TAPIERROR_ONLYCANCLOSEDAYS_QRY                               = 29101;
//! ֻƽǰʧ
const int TAPIERROR_ONLYCANCLOSEDAYS_ADD                               = 29102;
//! ֻƽǰɾʧ
const int TAPIERROR_ONLYCANCLOSEDAYS_DEL                               = 29103;
//! ֻƽǰ޸ʧ
const int TAPIERROR_ONLYCANCLOSEDAYS_MOD                               = 29104;

//=============================================================================
//! LMEϢѯʧ
const int TAPIERROR_LMETRADINGCALENDARINFO_QRY                         = 29201;
//! LMEϢʧ
const int TAPIERROR_LMETRADINGCALENDARINFO_ADD                         = 29202;
//! LMEϢ޸ʧ
const int TAPIERROR_LEMTRADINGCALENDARINFO_MOD                         = 29203;
//! LMEϢɾʧ
const int TAPIERROR_LEMTRADINGCALENDARINFO_DEL                         = 29204;
//! ݽղѯLMEϸڲѯʧ
const int TAPIERROR_LEM_TRADING_DETAILDATE_QRY                         = 29205;
//=============================================================================
//! ģѯʧ
const int TAPIERROR_TEMPLATE_MINMAX_FEE_QRY                            = 29301;
//! ģʧ
const int TAPIERROR_TEMPLATE_MINMAX_FEE_ADD                            = 29302;
//! ģɾʧ
const int TAPIERROR_TEMPLATE_MINMAX_FEE_DEL                            = 29303;
//! ģ޸ʧ
const int TAPIERROR_TEMPLATE_MINMAX_FEE_MOD                            = 29304;

// ģ弶ɾʧ
// const int		ERROR_TEMPLATE_MINMAX_FEE_CASCADE_DEL			= 29305;
//=============================================================================

//! ͻӦģѯʧ
const int TAPIERROR_ACCOUNT_MINMAX_FEETEMPLATE_QRY                     = 29401;
//! ͻӦģʧ
const int TAPIERROR_ACCOUNT_MINMAX_FEETEMPLATE_ADD                     = 29402;
//! ͻӦģɾʧ
const int TAPIERROR_ACCOUNT_MINMAX_FEETEMPLATE_DEL                     = 29403;
//! ͻӦģ޸ʧ
const int TAPIERROR_ACCOUNT_MINMAX_FEETEMPLATE_MOD                     = 29404;
//=============================================================================
//! ʽ˻һͨϵͳѯʧ
const int TAPIERROR_ACCOUNT_SEAT_INFO_QRY                              = 29411;
//! ʽ˻һͨϵͳʧ
const int TAPIERROR_ACCOUNT_SEAT_INFO_ADD                              = 29412;
//! ʽ˻һͨϵͳɾʧ
const int TAPIERROR_ACCOUNT_SEAT_INFO_DEL                              = 29413;
//=============================================================================
//! һͨ˺Ϣѯʧ
const int TAPIERROR_SEAT_INFO_QRY                                      = 29421;
//! һͨ˺Ϣʧ
const int TAPIERROR_SEAT_INFO_ADD                                      = 29422;
//! һͨ˺Ϣɾʧ
const int TAPIERROR_SEAT_INFO_DEL                                      = 29423;
//! һͨ˺ϢϯѴʧ
const int TAPIERROR_SEAT_INFO_MAIN_EXIT_ADD                            = 29422;
//=============================================================================
//! ͻѲѯʧ
const int TAPIERROR_ACCOUNTFEE_PARAMETER_QRY                           = 29431;
//! ͻձ֤ѯʧ
const int TAPIERROR_ACCOUNTMARGIN_PARAMETER_QRY                        = 29432;
//! ģ޸ʧ
const int TAPIERROR_TEMPLATEFEE_BATCH_MOD                              = 29433;
//! ֤ģ޸ʧ
const int TAPIERROR_TEMPLATEMARGIN_BATCH_MOD                           = 29434;
//=============================================================================
//! ڻ·ʲѯʧ
const int TAPIERROR_FOREIGN_EXCHANGE_NEWRATE_QRY                       = 29441;
//! ڻǰʲѯʧ
const int TAPIERROR_FOREIGN_EXCHANGE_CURRATE_QRY                       = 29442;
//! ڻ޸ʧ
const int TAPIERROR_FOREIGN_EXCHANGE_RATE_MOD                          = 29443;
//! ڻʧ
const int TAPIERROR_FOREIGN_EXCHANGE_RATE_ADD                          = 29444;
//! ڻɾʧ
const int TAPIERROR_FOREIGN_EXCHANGE_RATE_DEL                          = 29445;
//=============================================================================
//! ʼϢѯʧ
const int TAPIERROR_MAIL_INFO_QRY                                      = 29451;
//! ʼϢʧ
const int TAPIERROR_MAIL_INFO_ADD                                      = 29452;
//! ʼϢ޸ʧ
const int TAPIERROR_MAIL_INFO_MOD                                      = 29453;
//! ʼϢɾʧ
const int TAPIERROR_MAIL_INFO_DEL                                      = 29454;
//=============================================================================
//! ʲѯʧ
const int TAPIERROR_FOREX_RATE_INFO_QRY                                = 29461;
//! ʧ
const int TAPIERROR_FOREX_RATE_INFO_ADD                                = 29462;
//! ޸ʧ
const int TAPIERROR_FOREX_RATE_INFO_MOD                                = 29463;
//! ɾʧ
const int TAPIERROR_FOREX_RATE_INFO_DEL                                = 29464;
//=============================================================================
//! ڲѯʧ
const int TAPIERROR_FOREX_HOLIDAY_QRY                                  = 29471;
//! ʧ
const int TAPIERROR_FOREX_HOLIDAY_ADD                                  = 29472;
//! ޸ʧ
const int TAPIERROR_FOREX_HOLIDAY_MOD                                  = 29473;
//! ɾʧ
const int TAPIERROR_FOREX_HOLIDAY_DEL                                  = 29474;
//=============================================================================
//! ͻѯʧ
const int TAPIERROR_ACCOUNT_RELATEINFO_QRY                             = 29481;
//! ͻʧ
const int TAPIERROR_ACCOUNT_RELATEINFO_ADD                             = 29482;
//! ͻ޸ʧ
const int TAPIERROR_ACCOUNT_RELATEINFO_MOD                             = 29483;
//! ͻɾʧ
const int TAPIERROR_ACCOUNT_RELATEINFO_DEL                             = 29484;
//=============================================================================
//! 
//=============================================================================
//! ʷίвѯ
const int TAPIERROR_HISORDER_QRY                                       = 40001;
//! ʷίӴ
const int TAPIERROR_HISORDER_ADD                                       = 40002;
//! ʷί޸Ĵ
const int TAPIERROR_HISORDER_MOD                                       = 40003;
//! ʷίɾ
const int TAPIERROR_HISORDER_DEL                                       = 40004;
//! ׷ίвѯ
const int TAPIERROR_ORDERFORTRADE_QRY                                  = 40005;

//=============================================================================
//! ʷɽѯ
const int TAPIERROR_HISMATCH_QRY                                       = 40101;
//! ʷɽӴ
const int TAPIERROR_HISMATCH_ADD                                       = 40102;
//! ʷɽ޸Ĵ
const int TAPIERROR_HISMATCH_MOD                                       = 40103;
//! ʷɽɾ
const int TAPIERROR_HISMATCH_DEL                                       = 40104;
//! ׷ɽѯ
const int TAPIERROR_MATCHFORTRADE_QRY                                  = 40105;

//=============================================================================
//! ʷֲֲѯ
const int TAPIERROR_HISPOSITION_QRY                                    = 40201;
//! ʷֲӴ
const int TAPIERROR_HISPOSITION_ADD                                    = 40202;
//! ʷֲ޸Ĵ
const int TAPIERROR_HISPOSITION_MOD                                    = 40203;
//! ʷֲɾ
const int TAPIERROR_HISPOSITION_DEL                                    = 40204;
//! ׷ֲֲѯ
const int TAPIERROR_POSITIONFORTRADE_QRY                               = 40205;
//! һղѯ
const int TAPIERROR_LASTSETTLEDATE_QRY                                 = 40206;
//=============================================================================
//! ʷƽֲѯ
const int TAPIERROR_HISCLOSE_QRY                                       = 40301;

//=============================================================================
//! ʷδƽֲѯ
const int TAPIERROR_HISUNEXPCLOSE_QRY                                  = 40401;
//! ʷδƽӴ
const int TAPIERROR_HISUNEXPCLOSE_ADD                                  = 40402;
//! ʷδƽ޸Ĵ
const int TAPIERROR_HISUNEXPCLOSE_MOD                                  = 40403;
//! ʷδƽɾ
const int TAPIERROR_HISUNEXPCLOSE_DEL                                  = 40404;

//=============================================================================
//! ʷѯ
const int TAPIERROR_HISDELIVERY_QRY                                    = 40501;
//! ʷӴ
const int TAPIERROR_HISDELIVERY_ADD                                    = 40502;
//! ʷ޸Ĵ
const int TAPIERROR_HISDELIVERY_MOD                                    = 40503;
//! ʷɾ
const int TAPIERROR_HISDELIVERY_DEL                                    = 40504;

//=============================================================================
//! ۲ѯ
const int TAPIERROR_SETTLEPRICE_QRY                                    = 40601;
//! Ӵ
const int TAPIERROR_SETTLEPRICE_ADD                                    = 40602;
//! ޸Ĵ
const int TAPIERROR_SETTLEPRICE_MOD                                    = 40603;
//! ɾ
const int TAPIERROR_SETTLEPRICE_DEL                                    = 40604;

//=============================================================================
//! ЧԼɴ
const int TAPIERROR_VALIDCONTRACT_GEN                                  = 40701;

//=============================================================================
//! Ʋֲѯ
const int TAPIERROR_POSITIONMOVE_QRY                                   = 40801;
//! ƲӴ
const int TAPIERROR_POSITIONMOVE_ADD                                   = 40802;
//! Ʋɾ
const int TAPIERROR_POSITIONMOVE_DEL                                   = 40803;

//=============================================================================
//! ͻѯ
const int TAPIERROR_ACCOUNTCASHINOUT_QRY                               = 40901;
//! ͻӴ
const int TAPIERROR_ACCOUNTCASHINOUT_ADD                               = 40902;
//! ͻ֪ͨ
const int TAPIERROR_ACCOUNTCASHINOUTADD_NOTICE                         = 40903;

//=============================================================================
//! ͻʽѯ
const int TAPIERROR_ACCOUNTCASHADJUST_QRY                              = 41001;
//! ͻʽӴ
const int TAPIERROR_ACCOUNTCASHADJUST_ADD                              = 41002;
//! ͻʽ֪ͨ
const int TAPIERROR_ACCOUNTCASHADJUSTADD_NOTICE                        = 41003;



//=============================================================================
//! ͻʽҲѯ
const int TAPIERROR_ACCOUNTCASHSWAP_QRY                                = 41201;
//! ͻʽӴ
const int TAPIERROR_ACCOUNTCASHSWAP_ADD                                = 41202;
//! ͻʽ֪ͨ
const int TAPIERROR_ACCOUNTCASHSWAPADD_NOTICE                          = 41203;

//=============================================================================
//! ͻתϢѯ
const int TAPIERROR_TRANSFERINFO_QRY                                   = 41301;
//! ͻתϢӴ
const int TAPIERROR_TRANSFERINFO_ADD                                   = 41302;
//! ͻת֪ͨ
const int TAPIERROR_ATRANSFERINFOADD_NOTICE                            = 41303;

//=============================================================================
//! Span֤ѯ
const int TAPIERROR_SPANMARGIN_QRY                                     = 41401;
//! Span֤Ӵ
const int TAPIERROR_SPANMARGIN_ADD                                     = 41402;
//! Span֤޸Ĵ
const int TAPIERROR_SPANMARGIN_MOD                                     = 41403;
//! Span֤޸Ĵ
const int TAPIERROR_SPANMARGIN_DEL                                     = 41404;

//=============================================================================
//! ͻʽѯʧ
const int TAPIERROR_ACCOUNTFUND_QRY                                    = 41501;
//! ײѯͻʽʧ
const int TAPIERROR_ACCOUNTFUNDFORTRADE_QRY                            = 41502;
//! ͻʽʧ
const int TAPIERROR_ACCOUNTFUND_ADD                                    = 41503;
//! ͻʽɾʧ
const int TAPIERROR_ACCOUNTFUND_DEL                                    = 41504;

//=============================================================================
//! ͻʽѯ
const int TAPIERROR_ACCOUNTFROZENFUND_QRY                              = 41601;
//! ͻʽӴ
const int TAPIERROR_ACCOUNTFROZENFUND_ADD                              = 41602;
//! ͻʽ֪ͨ
const int TAPIERROR_ACCOUNTFROZENADD_NOTICE                            = 41603;
//! ͻʽ޸Ĵ
const int TAPIERROR_ACCOUNTFROZENFUND_MOD                              = 41604;
//! ͻʽ޸֪ͨ
const int TAPIERROR_ACCOUNTFROZENMOD_NOTICE                            = 41605;

//=============================================================================
//! ֳѯ
const int TAPIERROR_UPPERCASHINOUT_QRY                                 = 41701;
//! ֳӴ
const int TAPIERROR_UPPERCASHINOUT_ADD                                 = 41702;
//! ֳ޸Ĵ
const int TAPIERROR_UPPERCASHINOUT_MOD                                 = 41703;
//! ֳɾ
const int TAPIERROR_UPPERCASHINOUT_DEL                                 = 41704;

//=============================================================================
//! ʽѯ
const int TAPIERROR_UPPERCASHADJUST_QRY                                = 41801;
//! ʽӴ
const int TAPIERROR_UPPERCASHADJUST_ADD                                = 41802;
//! ʽ޸Ĵ
const int TAPIERROR_UPPERCASHADJUST_MOD                                = 41803;
//! ʽɾ
const int TAPIERROR_UPPERCASHADJUST_DEL                                = 41804;

//=============================================================================
//! ʽѯ
const int TAPIERROR_UPPERFUND_QRY                                      = 41901;

//=============================================================================
//! 
const int TAPIERROR_SETTLEDEAL_QRY                                     = 42001;

//=============================================================================
//! ̲ѯ
const int TAPIERROR_SETTLEPROCESS_QRY                                  = 42101;
//! κŲѯ
const int TAPIERROR_SettleBatchNo_QRY                                  = 42102;
//=============================================================================
//! ־ѯ
const int TAPIERROR_LOG_QRY                                            = 42201;

//=============================================================================
//! Ϣʹ
const int TAPIERROR_TRADEMESSAGE_SEND                                  = 42301;
//! Ϣѯ
const int TAPIERROR_TRADEMESSAGE_QRY                                   = 42302;
//! Ϣ֪ͨ
const int TAPIERROR_TRADEMESSAGE_NOTICE                                = 42303;

//=============================================================================
//! Ϣʹ
const int TAPIERROR_QUOTEMESSAGE_SEND                                  = 42401;
//! Ϣѯ
const int TAPIERROR_QUOTEMESSAGE_QRY                                   = 42402;
//! Ϣ֪ͨ
const int TAPIERROR_QUOTEMESSAGE_NOTICE                                = 42403;

//=============================================================================
//! ͳƱ
const int TAPIERROR_TRADINGSTATISTICS_REQ                              = 42501;

//=============================================================================
//! PCSʧ
const int TAPIERROR_PCS_REQ                                            = 42601;
//! CGMʧ
const int TAPIERROR_CGM_REQ                                            = 42602;
//! LargeTraderʧ
const int TAPIERROR_LARGETRADER_REQ                                    = 42603;
//! PCSѯʧ
const int TAPIERROR_PCS_QRY_REQ                                        = 42604;
//! CGMѯʧ
const int TAPIERROR_CGM_QRY_REQ                                        = 42605;
//! LargeTraderѯʧ
const int TAPIERROR_LARGETRADER_QRY_REQ                                = 42606;

//=============================================================================
//! CMEɽʧ
const int TAPIERROR_CME_MATCH_IMPORT_REQ                               = 42701;
//! CMEɽѯʧ
const int TAPIERROR_CME_MATCHT_QRY_REQ                                 = 42702;
//! CMEֲֵʧ
const int TAPIERROR_CME_POSITION_IMPORT_REQ                            = 42703;
//! CMEֲֲѯʧ
const int TAPIERROR_CME_POSITION_QRY_REQ                               = 42704;
//! CMEɽɾʧ
const int TAPIERROR_CMEMATCH_DEL_REQ                                   = 42705;
//! CMEֲɾʧ
const int TAPIERROR_CMEPOSITION_DEL_REQ                                = 42706;

//=============================================================================
//! MQɽʧ
const int TAPIERROR_MQ_MATCH_ADD_REQ                                   = 42801;
//! MQɽѯʧ
const int TAPIERROR_MQ_MATCHT_QRY_REQ                                  = 42802;

//=============================================================================
//! ˻ƽϢѯʧ
const int TAPIERROR_OMNIBUSACCOUNTCLOSEINFO_QRY_REQ                    = 42901;
//! ˻ƽϢʧ
const int TAPIERROR_OMNIBUSACCOUNTCLOSEINFO_ADD_REQ                    = 42902;
//! ˻ƽϢ޸ʧ
const int TAPIERROR_OMNIBUSACCOUNTCLOSEINFO_MOD_REQ                    = 42903;
//! ˻ƽϢɾʧ
const int TAPIERROR_OMNIBUSACCOUNTCLOSEINFO_DEL_REQ                    = 42904;

//=============================================================================
//! ɽ˶ʧ
const int TAPIERROR_CHECK_MATCH_REQ                                    = 43001;
//! ֲֺ˶ʧ
const int TAPIERROR_CHECK_POSITION_REQ                                 = 43002;

//=============================================================================
//! ֲִʧ
const int TAPIERROR_DEAL_POSITION_REQ                                  = 43101;

//=============================================================================
//! ֲ۵ֲѯʧ
const int TAPIERROR_POSITIONMORTGAGE_QRY_REQ                           = 43201;
//! ֲ۵ʧ
const int TAPIERROR_POSITIONMORTGAGE_ADD_REQ                           = 43202;
//! ֲ۵޸ʧ
const int TAPIERROR_POSITIONMORTGAGE_MOD_REQ                           = 43203;
//! ֲ۵ɾʧ
const int TAPIERROR_POSITIONMORTGAGE_DEL_REQ                           = 43204;

//=============================================================================
//! ֤ŻݲϢѯʧ
const int TAPIERROR_DCEMARGINPREFERENT_QRY_REQ                         = 43301;
//! ֤ŻݲϢʧ
const int TAPIERROR_DCEMARGINPREFERENT_ADD_REQ                         = 43302;
//! ֤ŻݲϢ޸ʧ
const int TAPIERROR_DCEMARGINPREFERENT_MOD_REQ                         = 43303;
//! ֤ŻݲϢɾʧ
const int TAPIERROR_DCEMARGINPREFERENT_DEL_REQ                         = 43304;

//=============================================================================
//! ֣Ϣѯʧ
const int TAPIERROR_ZCEAPPLYCMB_QRY_REQ                                = 43401;
//! ֣Ϣʧ
const int TAPIERROR_ZCEAPPLYCMB_ADD_REQ                                = 43402;
//! ֣Ϣ޸ʧ
const int TAPIERROR_ZCEAPPLYCMB_MOD_REQ                                = 43403;
//! ֣Ϣɾʧ
const int TAPIERROR_ZCEAPPLYCMB_DEL_REQ                                = 43404;

//=============================================================================
//! ɽ˶Աʧ
const int TAPIERROR_MATCHREPORT_REQ                                    = 43501;
//! ֲֺ˶Աʧ
const int TAPIERROR_POSITIONREPORT_REQ                                 = 43502;

//=============================================================================
//! ͻʽʧ
const int TAPIERROR_ACCOUNTAUTHCASH_ADD_REQ                            = 43601;
//! ͻʽѯʧ
const int TAPIERROR_ACCOUNTAUTHCASH_DEL_REQ                            = 43602;


//=============================================================================
//! ֲֺ̳˶
const int TAPIERROR_FOREIGNPOSITION_CHECK_REQ                          = 43701;
//! ̿ͻʽ˶		
const int TAPIERROR_ACCOUNTFUND_CHECK_REQ                              = 43702;
//! δƽֺ˶
const int TAPIERROR_UNEXPCLOSE_CHECK_REQ                               = 43703;

//=============================================================================
//! ʽѯ
const int TAPIERROR_OTHERFUND_QRY_REQ                                  = 43801;
//! ʽ		
const int TAPIERROR_OTHERFUND_ADD_REQ                                  = 43802;
//! ʽ޸
const int TAPIERROR_OTHERFUND_MOD_REQ                                  = 43803;
//! ʽɾ
const int TAPIERROR_OTHERFUND_DEL_REQ                                  = 43804;

//=============================================================================
//! ͻʽˢ֪ͨ
const int TAPIERROR_ACCOUNTFUND_NOTICE_REQ                             = 43901;

//=============================================================================
//! ݿͻƲϢѯ
const int TAPIERROR_POSITIONMOVEBYACCOUNT_QRY_REQ                      = 44001;
//! ݿͻƲϢ		
const int TAPIERROR_POSITIONMOVEBYACCOUNT_ADD_REQ                      = 44002;
//! ݿͻƲϢ޸
const int TAPIERROR_POSITIONMOVEBYACCOUNT_MOD_REQ                      = 44003;
//! ݿͻƲϢɾ
const int TAPIERROR_POSITIONMOVEBYACCOUNT_DEL_REQ                      = 44004;

//=============================================================================
//! 
const int TAPIERROR_ADJUSTMATCH_REQ                                    = 44101;

//=============================================================================
//! ֪ͨ
const int TAPIERROR_SWAPREPORT_REQ                                     = 44201;

//=============================================================================
//! ׷ǿƽ
const int TAPIERROR_ADDFOURCEREPORT_REQ                                = 44301;

//=============================================================================
//! ʽ˱
const int TAPIERROR_ACCOUNTFUNDREPORT_REQ                              = 44401;

//=============================================================================
//! ʾ
const int TAPIERROR_DELIVERYALARMREPORT_REQ                            = 44501;

//=============================================================================
//! ߿ռ۸ѯ
const int TAPIERROR_OHCL_QRY_REQ                                       = 446001;
//! ߿ռ۸		
const int TAPIERROR_OHCL_ADD_REQ                                       = 44602;
//! ߿ռ۸޸
const int TAPIERROR_OHCL_MOD_REQ                                       = 44603;
//! ߿ռ۸ɾ
const int TAPIERROR_OHCL_DEL_REQ                                       = 44604;

//=============================================================================
//! Ϣѯ
const int TAPIERROR_TODELIVERY_QRY_REQ                                 = 44701;
//! Ϣ		
const int TAPIERROR_TODELIVERY_ADD_REQ                                 = 44702;
//! Ϣ޸
const int TAPIERROR_TODELIVERY_MOD_REQ                                 = 44703;
//! Ϣɾ
const int TAPIERROR_TODELIVERY_DEL_REQ                                 = 44704;

//=============================================================================
//! ͻѺʽѯ
const int TAPIERROR_ACCOUNTPLEDGE_QRY_REQ                              = 44801;
//! ͻѺʽ		
const int TAPIERROR_ACCOUNTPLEDGE_ADD_REQ                              = 44802;

//=============================================================================
//! ͻۻѯ
const int TAPIERROR_SETTLESALE_QRY_REQ                                 = 44901;
//! ͻۻ		
const int TAPIERROR_SETTLESALE_ADD_REQ                                 = 44902;
//! ͻۻɾ		
const int TAPIERROR_SETTLESALE_DEL_REQ                                 = 44903;


//=============================================================================
//! Ƶʹ
const int TAPIERROR_ORDER_FREQUENCY                                    = 61001;
//! ίвѯǰܽ´βѯ
const int TAPIERROR_ORDER_QUERYING                                     = 61002;

//=============================================================================
//! һݰոѯʧ
const int TAPIERROR_1MINUTEBYCOUNT_QRY                                 = 70101;
//! һݰʱβѯʧ	
const int TAPIERROR_1MINUTEBYPERIOD_QRY                                = 70102;
//! һݰDATEѯʧ	
const int TAPIERROR_1MINUTEBYDATE_QRY                                  = 70103;

//=============================================================================
//! ݰոѯʧ
const int TAPIERROR_3MINUTEBYCOUNT_QRY                                 = 70201;
//! ݰʱβѯʧ	
const int TAPIERROR_3MINUTEBYPERIOD_QRY                                = 70202;
//! ݰDATEѯʧ	
const int TAPIERROR_3MINUTEBYDATE_QRY                                  = 70203;

//=============================================================================
//! ݰոѯʧ
const int TAPIERROR_5MINUTEBYCOUNT_QRY                                 = 70301;
//! ݰʱβѯʧ	
const int TAPIERROR_5MINUTEBYPERIOD_QRY                                = 70302;
//! ݰDATEѯʧ	
const int TAPIERROR_5MINUTEBYDATE_QRY                                  = 70303;

//=============================================================================
//! ʮݰոѯʧ
const int TAPIERROR_10MINUTEBYCOUNT_QRY                                = 70401;
//! ʮݰʱβѯʧ	
const int TAPIERROR_10MINUTEBYPERIOD_QRY                               = 70402;
//! ʮݰDATEѯʧ	
const int TAPIERROR_10MINUTEBYDATE_QRY                                 = 70403;

//=============================================================================
//! ʮݰոѯʧ
const int TAPIERROR_15MINUTEBYCOUNT_QRY                                = 70501;
//! ʮݰʱβѯʧ	
const int TAPIERROR_15MINUTEBYPERIOD_QRY                               = 70502;
//! ʮݰDATEѯʧ	
const int TAPIERROR_15MINUTEBYDATE_QRY                                 = 70503;

//=============================================================================
//! ʮݰոѯʧ
const int TAPIERROR_30MINUTEBYCOUNT_QRY                                = 70601;
//! ʮݰʱβѯʧ	
const int TAPIERROR_30MINUTEBYPERIOD_QRY                               = 70602;
//! ʮݰDATEѯʧ	
const int TAPIERROR_30MINUTEBYDATE_QRY                                 = 70603;

//=============================================================================
//! ʮݰոѯʧ
const int TAPIERROR_60MINUTEBYCOUNT_QRY                                = 70701;
//! ʮݰʱβѯʧ	
const int TAPIERROR_60MINUTEBYPERIOD_QRY                               = 70702;
//! ʮݰDATEѯʧ	
const int TAPIERROR_60MINUTEBYDATE_QRY                                 = 70703;

//=============================================================================
//! 120ݰոѯʧ
const int TAPIERROR_120MINUTEBYCOUNT_QRY                               = 70801;
//! 120ݰʱβѯʧ	
const int TAPIERROR_120MINUTEBYPERIOD_QRY                              = 70802;
//! 120ݰDATEѯʧ	
const int TAPIERROR_120MINUTEBYDATE_QRY                                = 70803;

//=============================================================================
//! 240ݰոѯʧ
const int TAPIERROR_240MINUTEBYCOUNT_QRY                               = 70901;
//! 240ݰʱβѯʧ	
const int TAPIERROR_240MINUTEBYPERIOD_QRY                              = 70902;
//! 240ݰDATEѯʧ	
const int TAPIERROR_240MINUTEBYDATE_QRY                                = 70903;

//=============================================================================
//! 30ݰոѯʧ
const int TAPIERROR_30SECONDSBYCOUNT_QRY                               = 71001;
//! 30ݰʱβѯʧ	
const int TAPIERROR_30SECONDSBYPERIOD_QRY                              = 71002;
//! 30ݰDATEѯʧ	
const int TAPIERROR_30SECONDSBYDATE_QRY                                = 71003;

//=============================================================================
//! Tickݰոѯʧ
const int TAPIERROR_TICKBYCOUNT_QRY                                    = 71101;
//! Tickݰʱβѯʧ	
const int TAPIERROR_TICKBYPERIOD_QRY                                   = 71102;
//! TickݰDATEѯʧ	
const int TAPIERROR_TICKBYDATE_QRY                                     = 71103;

//=============================================================================
//! ݰոѯʧ
const int TAPIERROR_DAYBYCOUNT_QRY                                     = 71201;
//! ݰʱβѯʧ	
const int TAPIERROR_DAYBYPERIOD_QRY                                    = 71202;
//! ݰDATEѯʧ	
const int TAPIERROR_DAYBYDATE_QRY                                      = 71203;

//=============================================================================
//! ݰոѯʧ
const int TAPIERROR_WEEKBYCOUNT_QRY                                    = 71301;
//! ݰʱβѯʧ	
const int TAPIERROR_WEEKBYPERIOD_QRY                                   = 71302;
//! ݰDATEѯʧ	
const int TAPIERROR_WEEKBYDATE_QRY                                     = 71303;

//=============================================================================
//! ݰոѯʧ
const int TAPIERROR_MONTHBYCOUNT_QRY                                   = 71401;
//! ݰʱβѯʧ	
const int TAPIERROR_MONTHBYPERIOD_QRY                                  = 71402;
//! ݰDATEѯʧ	
const int TAPIERROR_MONTHBYDATE_QRY                                    = 71403;

//=============================================================================
//! ݰոѯʧ
const int TAPIERROR_YEARBYCOUNT_QRY                                    = 71501;
//! ݰʱβѯʧ	
const int TAPIERROR_YEARBYPERIOD_QRY                                   = 71502;
//! ݰDATEѯʧ	
const int TAPIERROR_YEARBYDATE_QRY                                     = 71503;

//=============================================================================
//! Nݰոѯʧ
const int TAPIERROR_NMINUTESBYCOUNT_QRY                                = 71601;
//! Nݰʱβѯʧ	
const int TAPIERROR_NMINUTESBYPERIOD_QRY                               = 71602;
//! NݰDATEѯʧ	
const int TAPIERROR_NMINUTESBYDATE_QRY                                 = 71603;

//=============================================================================
//! Nݰոѯʧ
const int TAPIERROR_NDAYSBYCOUNT_QRY                                   = 71701;
//! Nݰʱβѯʧ	
const int TAPIERROR_NDAYSBYPERIOD_QRY                                  = 71702;
//! NݰDATEѯʧ	
const int TAPIERROR_NDAYSBYDATE_QRY                                    = 71703;
//=============================================================================
//! Nݰոѯʧ
const int TAPIERROR_NSECONDBYCOUNT_QRY                                 = 71801;
//! Nݰʱβѯʧ	
const int TAPIERROR_NSECONDSBYPERIOD_QRY                               = 71802;
//! NݰDATEѯʧ	
const int TAPIERROR_NSECONDSBYDATE_QRY                                 = 71803;

//! ܶ
const int TAPIERROR_SUBSCRIBEQUOTE_MAX                                 = 72001;
//! ý
const int TAPIERROR_SUBSCRIBEQUOTE_EXCHANGE_MAX                        = 72002;
//! ûиĶȨ
const int TAPIERROR_SUBSCRIBEQUOTE_NO_RIGHT                            = 72101;
//! ûиýĶȨ
const int TAPIERROR_SUBSCRIBEQUOTE_NO_EXCHANGE_RIGHT                   = 72102;
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_ERR_TAP_UPPER_GW	ش붨
 *	@{
 */
//=============================================================================
//! ʧ
const int TAPIERROR_ORDER_SEND                                         = 80001;
//! ͱʧܣûӵ
const int TAPIERROR_DLG_NULL                                           = 80002;
//! ֶ
const int TAPIERROR_ORDER_FIELD                                        = 80003;
//! ־ܾ
const int TAPIERROR_TRADE_REJ_BYUPPER                                  = 80004;

/** @}*/

//=============================================================================
/**
 *	\addtogroup G_ERR_TAP_PROTOCOL	tapЭAPI붨
 *	@{
 */
//=============================================================================

//! ׷ʧ
const int TAPIERROR_TAPSERVER_CREATE                                   = 81001;
//! ʧ
const int TAPIERROR_CONNECT_BUS                                        = 81002;
//! յݴ
const int TAPIERROR_GWRCV_DATA                                         = 81003;
//! ֡ͷʶ
const int TAPIERROR_FRAME_FLAG                                         = 81004;
//! ݲȫ
const int TAPIERROR_GWREC_DATA_PARTICAL                                = 81005;
//! FrameHead_TYPE
const int TAPIERROR_FRAMEHEAD_TYPE                                     = 81006;
//! 	
const int TAPIERROR_MANAGESERVER_MATCH                                 = 81007;
//! ûжӦڲ
const int TAPIERROR_QRY_INNERCOMM0DITY                                 = 81008;
//! ûжӦĿͻ
const int TAPIERROR_CLIENTNO                                           = 81009;
//! ûܶӦⲿ
const int TAPIERROR_QRY_UPPERCOMMODITY                                 = 81010;
//! صǰܲѯʱ
const int TAPIERROR_QRY_MARKETSTATE                                    = 81011;
//! ׷ʧ
const int TAPIERROR_TRADEFRONT_TAPSERVER_CREATE                        = 82001;
//! ʧ
const int TAPIERROR_TRADEFRONT_CONNECT_BUS                             = 82002;
//! ·߳ʧ
const int TAPIERROR_TRADEFRONT_LINK_THREAD                             = 82003;
//! ĵ¼ʧ
const int TAPIERROR_TRADEFRONT_SUBLOGIN                                = 82004;
//! ĵ¼ѯʧ
const int TAPIERROR_TRADEFRONT_SUBLOGINQUERY                           = 82005;
//! Ĺʧ
const int TAPIERROR_TRADEFRONT_SUBMANAGEBASIC                          = 82006;
//! Ĺ߼ʧ
const int TAPIERROR_TRADEFRONT_SUBMANAGEADVANCED                       = 82007;
//! Ľʧ
const int TAPIERROR_TRADEFRONT_SUBSETTLE                               = 82008;
//! ĽϢʧ
const int TAPIERROR_TRADEFRONT_SUBSETTLEMESSAGE                        = 82009;
//! Ľʽʧ
const int TAPIERROR_TRADEFRONT_SUBSETTLEMONEY                          = 82010;
//! Ľ׷ʧ
const int TAPIERROR_TRADEFRONT_SUBTRADE                                = 82011;
//! ɶ˿ڴʧ
const int TAPIERROR_TRADEFRONT_SERVERSTART_IOCP                        = 82012;
//! ߳ʧ
const int TAPIERROR_TRADEFRONT_SERVERSTART_WORKER                      = 82013;
//! ߳ʧ
const int TAPIERROR_TRADEFRONT_SERVERSTART_LISTEN                      = 82014;
//! ˿ʧ
const int TAPIERROR_TRADEFRONT_SERVERSTART_PORT                        = 82015;
//! ǰòģ¼
const int TAPIERROR_TRADEFRONT_MODULETYPEERR                           = 82016;
//! ǰύʧ
const int TAPIERROR_TRADEFRONT_SENDDATAERR                             = 82017;
//! ǰò¼
const int TAPIERROR_TRADEFRONT_NOTALLOWLOGIN                           = 82018;
//! һ̫
const int TAPIERROR_TRADEFRONT_TOOMANYDATA                             = 82019;
//! ǰûҪ
const int TAPIERROR_TRADEFRONT_NODATA                                  = 82020;
//! µʧܣСǰϿ
const int TAPIERROR_TRADEFRONT_DICONNECT_SMTRADE                       = 82021;
//! µʧܣǰ뽻׷Ͽ
const int TAPIERROR_TRADEFRONT_DICONNECT_TRADE                         = 82022;
// ----------------ǰô붨-----------------------------------------------
//! ֵ֧Э
const int TAPIERROR_QUOTEFRONT_UNKNOWN_PROTOCOL                        = 83001;

/** @}*/

//=============================================================================
/**
 *	\addtogroup G_ERR_TAP_FUTUREBANK	ڷ붨
 *	@{
 */
//=============================================================================
//! ڻʽ˻
const int TAPIERROR_ACCOUNTNO_NOEXIT                                   = 90001;
//! вڻ˷ǩԼ
const int TAPIERROR_BANKSINGED_NOTALLOW                                = 90002;
//! ֤
const int TAPIERROR_BANKPASSWORDAUTH                                   = 90003;
//! ˻ûиñʽ¼
const int TAPIERROR_BANKFUTUREVALUE_NOTEXIT                            = 90004;
//! ˻Ӧֳڿתʽ
const int TAPIERROR_BANKFUTURETRANSFER_NOTENOUGH                       = 90005;
//! ˻Ӧֳ𳬹
const int TAPIERROR_BANKFUTURETRANSFER_MORE_SIGMAXVALUE                = 90006;
//! ˻Ӧֳ𳬹
const int TAPIERROR_BANKFUTURETRANSFER_MORE_DAYMAXCOUNT                = 90007;
//! ˻Ӧֳ𳬹
const int TAPIERROR_BANKFUTURETRANSFER_MORE_DAYMAXVALUE                = 90008;
//! ʽ𶳽ʧ
const int TAPIERROR_FUTURE_FROZEN_FAIL                                 = 90009;
//! ת˲ѯ˻Ϣ
const int TAPIERROR_BANKFUTURETRANSFER_FTOB_NOACCINFO                  = 90010;
//! ת˲ѯͻϢ
const int TAPIERROR_BANKFUTURETRANSFER_FTOB_NOACCBANKINFO              = 90011;
//! ת˲ѯͻʽϢ
const int TAPIERROR_BANKFUTURETRANSFER_FTOB_NOACCFUNDINFO              = 90012;
//! ת˲ѯת˲Ϣ
const int TAPIERROR_BANKFUTURETRANSFER_FTOB_NORENTINFO                 = 90013;
//! ת˲ѯѳϢ
const int TAPIERROR_BANKFUTURETRANSFER_FTOB_NOCOUNTVALUEINFO           = 90014;
//! ת˲ѯ˻֤Ϣ
const int TAPIERROR_BANKFUTURETRANSFER_FTOB_NOACCCERTINFO              = 90015;
//! û쳣
const int TAPIERROR_BANKWAY_STOP                                       = 90016;
//! ûյʧתˮ
const int TAPIERROR_TRANSFERINFO_LOST                                  = 90017;
//! ͻнֹת
const int TAPIERROR_BANK_NOTALLOWTRANSFER                              = 90018;
//! תڻ,޷
const int TAPIERROR_CASHIN_NOREVERSE                                   = 90019;

// ----------------ռط붨-----------------------------------------------
//! ƷϢѯʧ
const int TAPIERROR_RISKCOMMODITY_QRY                                  = 91001;
//! ԤѯԼϢ
const int TAPIERROR_RISKCONTRACT_FUND                                  = 91002;
//! ʽѯղ
const int TAPIERROR_RISKFUND_QRY                                       = 91003;
//! Լ۸ʧ
const int TAPIERROR_CONTRACTQUOTE_ADD                                  = 91004;

/** @}*/

#endif //! TAP_API_ERROR_H
