#ifndef TAP_QUOTE_API_DATA_TYPE_H
#define TAP_QUOTE_API_DATA_TYPE_H
//ļTapQuoteAPI ʹõͺݽṹ

#include "TapAPICommDef.h"

#pragma pack(push, 1)

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_Q_BASIC	
 *	@{
 */
//=============================================================================

//! ۸
typedef TAPIREAL64		TAPIQPRICE;
//! 
typedef TAPIUINT64		TAPIQVOLUME;
//! 仯ֵ
typedef TAPIINT64		TAPIQDIFF;	

/** @}*/


//=============================================================================
/**
 *	\addtogroup G_DATATYPE_Q_TAPIBUKETDATEFLAG	ʱڱ
 *	@{
 */
//=============================================================================

//! ʱڱ
typedef TAPICHAR			TAPIBucketDateFlag;
//! ǰһʱ
const TAPIBucketDateFlag	TAPI_TIMEBUCKETDATEFLAG_PREDAY	='0';
//! 
const TAPIBucketDateFlag	TAPI_TIMEBUCKETDATEFLAG_CURDAY	='1';
//! һ
const TAPIBucketDateFlag	TAPI_TIMEBUCKETDATEFLAG_NEXTDAY	='2';

/** @}*/


//=============================================================================
/**
 *	\addtogroup G_DATATYPE_Q_HISQUOTETYPE	ʷ
 *	@{
 */
//=============================================================================
//! ʷ
typedef TAPICHAR			TAPIHisQuoteType;
//! 
const TAPIHisQuoteType	TAPI_HISQUOTETYPE_MINUTE		= '0';
//! 
const TAPIHisQuoteType	TAPI_HISQUOTETYPE_DAY			= '1';
/** @}*/


//=============================================================================
/**
 *	\addtogroup G_STRUCT_Q	ṹ嶨
 *	@{
 */
//=============================================================================

//! ¼֤Ϣ
struct TapAPIQuoteLoginAuth
{
	TAPISTR_20			UserNo;					///< û
	TAPIYNFLAG			ISModifyPassword;		///< Ƿ޸룬'Y'ʾǣ'N'ʾ
	TAPISTR_20			Password;				///< û
	TAPISTR_20			NewPassword;			///< 룬޸Ҫдֶ
	TAPISTR_20			QuoteTempPassword;		///< ʱ
	TAPIYNFLAG			ISDDA;					///< Ƿѽ̬֤'Y'ʾǣ'N'ʾ
	TAPISTR_30			DDASerialNo;			///< ̬֤
};

//! ¼Ϣ
struct TapAPIQuotLoginRspInfo
{
	TAPISTR_20					UserNo;							///< û
	TAPIINT32					UserType;						///< û
	TAPISTR_20					UserName;						///< ǳƣGBKʽ
	TAPISTR_20					QuoteTempPassword;				///< ʱ
	TAPISTR_50					ReservedInfo;					///< ûԼõԤϢ
	TAPISTR_40					LastLoginIP;					///< ϴε¼ĵַ
	TAPIUINT32					LastLoginProt;					///< ϴε¼ʹõĶ˿
	TAPIDATETIME				LastLoginTime;					///< ϴε¼ʱ
	TAPIDATETIME				LastLogoutTime;					///< ϴ˳ʱ
	TAPIDATE					TradeDate;						///< ǰ
	TAPIDATETIME				LastSettleTime;					///< ϴνʱ
	TAPIDATETIME				StartTime;						///< ϵͳʱ
	TAPIDATETIME				InitTime;						///< ϵͳʼʱ
};


//! ƷϢ
struct TapAPIQuoteCommodityInfo
{
	TapAPICommodity			Commodity;							///< Ʒ
	TAPISTR_20				CommodityName;						///< Ʒ,GBKʽ
	TAPISTR_30				CommodityEngName;					///< ƷӢ
	TAPIREAL64				ContractSize;						///< ÿֳ
	TAPIREAL64				CommodityTickSize;					///< С䶯λ
	TAPIINT32				CommodityDenominator;				///< ۷ĸ
	TAPICHAR                CmbDirect;							///< Ϸ
	TAPIINT32				CommodityContractLen;				///< ƷֺԼ
	TAPIYNFLAG				IsDST;								///< Ƿʱ,'Y'Ϊ,'N'Ϊ
	TapAPICommodity			RelateCommodity1;					///< Ʒ1
	TapAPICommodity			RelateCommodity2;					///< Ʒ2
};

//! ʷѯṹ
struct TapAPIHisQuoteQryReq
{
	TapAPIContract		Contract;								///< Լ
	TAPIHisQuoteType	HisQuoteType;							///< K
	TAPIDATETIME		HisQuoteEndTime;						///< K߽ʱ
	TAPIUINT64			HisQuoteCandleQryCount;					///< K߸
};

//! ԼϢ
struct TapAPIQuoteContractInfo
{
	TapAPIContract				Contract;							///< Լ
	TAPICHAR					ContractType;                       ///< Լ,'1'ʾԼ,'2'ʾԼ
	TAPISTR_10					QuoteUnderlyingContract;			///< ʵԼ
	TAPISTR_70					ContractName;                       ///< Լ
	TAPIDATE					ContractExpDate;                    ///< Լ	
	TAPIDATE					LastTradeDate;                      ///< 
	TAPIDATE					FirstNoticeDate;                    ///< ״֪ͨ
};

//! ʱ
struct TapAPITradingTimeBucket
{
	TAPIINT32				TradingTimeBucketID;                    ///< ʱα
	TAPITIME				TimeBucketBeginTime;                    ///< ʱοʼʱ
	TAPICHAR				TradingState;                           ///< ״̬
	TAPIYNFLAG				IsDST;                                  ///< Ƿʱ,'Y'Ϊ,'N'Ϊ
	TAPIBucketDateFlag		DateFlag;								///< ձ־
};

//! ʱβѯӦṹ
struct TapAPITimeBucketOfCommodityInfo
{
	TapAPICommodity				Commodity;							///< Ʒ
	TAPIUINT32					Count;								///< ʱθ
	TapAPITradingTimeBucket*	TimeBuckets;						///< ʱ׵ַ
};


//! ȫ
struct TapAPIQuoteWhole
{
	TapAPIContract				Contract;						///< Լ
	TAPISTR_10					CurrencyNo;						///< ֱ
	TAPICHAR					TradingState;					///< ״̬1,Ͼ;2,Ͼ۴;3,;4,ͣ;5,
	TAPIDTSTAMP					DateTimeStamp;					///< ʱ
	TAPIQPRICE					QPreClosingPrice;				///< ̼
	TAPIQPRICE					QPreSettlePrice;				///< 
	TAPIQVOLUME					QPrePositionQty;				///< ֲ
	TAPIQPRICE					QOpeningPrice;					///< ̼
	TAPIQPRICE					QLastPrice;						///< ¼
	TAPIQPRICE					QHighPrice;						///< ߼
	TAPIQPRICE					QLowPrice;						///< ͼ
	TAPIQPRICE					QHisHighPrice;					///< ʷ߼
	TAPIQPRICE					QHisLowPrice;					///< ʷͼ
	TAPIQPRICE					QLimitUpPrice;					///< ͣ
	TAPIQPRICE					QLimitDownPrice;				///< ͣ
	TAPIQVOLUME					QTotalQty;						///< ܳɽ
	TAPIQPRICE					QTotalTurnover;					///< ճɽ
	TAPIQVOLUME					QPositionQty;					///< ֲ
	TAPIQPRICE					QAveragePrice;					///< 
	TAPIQPRICE					QClosingPrice;					///< ̼
	TAPIQPRICE					QSettlePrice;					///< 
	TAPIQVOLUME					QLastQty;						///< ³ɽ
	TAPIQPRICE					QBidPrice[20];					///< 1-20
	TAPIQVOLUME					QBidQty[20];					///< 1-20
	TAPIQPRICE					QAskPrice[20];					///< 1-20
	TAPIQVOLUME					QAskQty[20];					///< 1-20
	TAPIQPRICE					QImpliedBidPrice;				///< 
	TAPIQVOLUME					QImpliedBidQty;					///< 
	TAPIQPRICE					QImpliedAskPrice;				///< 
	TAPIQVOLUME					QImpliedAskQty;					///< 
	TAPIQPRICE					QPreDelta;						///< ʵ
	TAPIQPRICE					QCurrDelta;						///< ʵ
	TAPIQVOLUME					QInsideQty;						///< 
	TAPIQVOLUME					QOutsideQty;					///< 
	TAPIQPRICE					QTurnoverRate;					///< 
	TAPIQVOLUME					Q5DAvgQty;						///< վ
	TAPIQPRICE					QPERatio;						///< ӯ
	TAPIQPRICE					QTotalValue;					///< ֵ
	TAPIQPRICE					QNegotiableValue;				///< ֵͨ
	TAPIQDIFF					QPositionTrend;					///< ֲ
	TAPIQPRICE					QChangeSpeed;					///< 
	TAPIQPRICE					QChangeRate;					///< Ƿ
	TAPIQPRICE					QChangeValue;					///< ǵֵ
	TAPIQPRICE					QSwing;							///< 
	TAPIQVOLUME					QTotalBidQty;					///< ί
	TAPIQVOLUME					QTotalAskQty;					///< ί
};



//! ʷ
struct TapAPIHisQuote
{
	TAPIHisQuoteType			HisQuoteType;					///< ʷ
	TapAPIContract				Contract;						///< Լ
	TAPIDTSTAMP					DateTimeStamp;					///< ʱ
	TAPIDATE					TradeDate;						///< 
	TAPIUINT32					KLineIndex;						///< K
	TAPIQPRICE					QOpeningPrice;					///< ̼
	TAPIQPRICE					QLastPrice;						///< ¼
	TAPIQPRICE					QHighPrice;						///< ߼
	TAPIQPRICE					QLowPrice;						///< ͼ
	TAPIQVOLUME					QTotalQty;						///< ܳɽ
	TAPIQVOLUME					QPositionQty;					///< ֲ
	TAPIQPRICE					QSettlePrice;					///< 
	TAPIQVOLUME					QKLineTotalQty;					///< Kܳɽ
};	

//! ʷѯӦṹ
struct TapAPIHisQuoteQryRsp
{
	TAPIUINT32					Count;							///< ʷ
	TapAPIHisQuote*				HisQuotes;						///< ʷ׵ַ
};


/** @}*/





#pragma pack(pop)

#endif